// API_VS2005Dlg.h : header file
//

#pragma once

#include "SCANAPIAX.h"

typedef BOOL (_stdcall *pfnAPI_Register)(HWND hwnd);
typedef void (_stdcall *pfnAPI_Unregister)(void);
typedef UINT (_stdcall *pfnAPI_GetBarData)(LPBYTE buffer, UINT	*uiLength, UINT	*uiBarType);
typedef UINT (_stdcall *pfnAPI_GetBarDataLength)(void);
typedef UINT (_stdcall *pfnAPI_GetBarType)(void);
typedef DWORD (_stdcall *pfnAPI_GetError)(void);
typedef DWORD (_stdcall *pfnAPI_GetSysError)(void);
typedef void (_stdcall *pfnAPI_GoodRead)(void);
typedef BOOL (_stdcall *pfnAPI_LoadSettingsFromFile)(LPCTSTR filename);
typedef BOOL (_stdcall *pfnAPI_Reset)(void);
typedef void (_stdcall *pfnAPI_ResetBarData)(void);
typedef BOOL (_stdcall *pfnAPI_SaveSettingsToFile)(LPCTSTR filename);
typedef BOOL (_stdcall *pfnAPI_SaveSettingsToScanner)(void);
typedef BOOL (_stdcall *pfnS2K_IsLoad)(void);
typedef BOOL (_stdcall *pfnS2K_Load)(BOOL bLoad, DWORD dwTimeOut);
typedef BOOL (_stdcall *pfnSCAN_QueryStatus)(int nCommand1, int nCommand2, char *pReturn);
typedef BOOL (_stdcall *pfnSCAN_SendCommand)(int nCommand1, int nCommand2, char *pValue);
typedef DWORD (_stdcall *pfnSCAN_BatchSetting)(ScannerSetting setting);
typedef DWORD (_stdcall *pfnSCAN_BatchRead)(ScannerSetting *ReadBuf);

typedef DWORD (_stdcall *pfnEnableTriggerKey)(BOOL bEnable);
typedef int (_stdcall *pfnGetLibraryVersion)(void);
typedef DWORD (_stdcall *pfnGetTriggerKeyStatus)(void);
typedef DWORD (_stdcall *pfnPressTriggerKey)(BOOL bPress);
typedef DWORD (_stdcall *pfnTriggerKeyStatus)(void);

// CAPI_VS2005Dlg dialog
class CAPI_VS2005Dlg : public CDialog
{
// Construction
public:
	CAPI_VS2005Dlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_API_VS2005_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
	HICON m_hIcon;
	HINSTANCE m_hLibrary;

	pfnAPI_Register				m_API_Register;
	pfnAPI_Unregister				m_API_Unregister;
	pfnAPI_GetBarData			m_API_GetBarData;
	pfnAPI_GetBarDataLength		m_API_GetBarDataLength;
	pfnAPI_GetBarType			m_API_GetBarType;
	pfnAPI_GetError				m_API_GetError;
	pfnAPI_GetSysError			m_API_GetSysError;
	pfnAPI_GoodRead				m_API_GoodRead;
	pfnAPI_LoadSettingsFromFile	m_API_LoadSettingsFromFile;
	pfnAPI_Reset					m_API_Reset;
	pfnAPI_ResetBarData			m_API_ResetBarData;
	pfnAPI_SaveSettingsToFile		m_API_SaveSettingsToFile;
	pfnAPI_SaveSettingsToScanner	m_API_SaveSettingsToScanner;
	pfnS2K_IsLoad				m_S2K_IsLoad;
	pfnS2K_Load					m_S2K_Load;
	pfnSCAN_QueryStatus			m_SCAN_QueryStatus;
	pfnSCAN_SendCommand		m_SCAN_SendCommand;
	pfnSCAN_BatchSetting			m_SCAN_BatchSetting;
	pfnSCAN_BatchRead				m_SCAN_BatchRead;

	pfnEnableTriggerKey			m_EnableTriggerKey;
	pfnGetLibraryVersion			m_GetLibraryVersion;
	pfnGetTriggerKeyStatus		m_GetTriggerKeyStatus;
	pfnPressTriggerKey			m_PressTriggerKey;
	pfnTriggerKeyStatus			m_TriggerKeyStatus;

	// Generated message map functions
	virtual BOOL OnInitDialog();
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
#endif
	DECLARE_MESSAGE_MAP()

protected:
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual void OnOK();

public:
	CString m_strBarType;
	CString m_strBarData;
	UINT m_uiLength;
	UINT m_uiGetType;
	int m_uiCommand1;
	int m_uiCommand2;
	CString m_strValue;

	afx_msg void OnBnClickedBtnBatch();
	afx_msg void OnBnClickedBtnLoadscan();
	afx_msg void OnBnClickedBtnVersion();
	afx_msg void OnBnClickedBtnTrigger();
	afx_msg void OnBnClickedBtnDetecttrigger();
	afx_msg void OnBnClickedBtnPressTrigger();
	afx_msg void OnBnClickedBtnSavesetting();
	afx_msg void OnBnClickedBtnSavetofile();
	afx_msg void OnBnClickedBtnLoadfromfile();
	afx_msg void OnBnClickedBtnReset();
	afx_msg void OnBnClickedBtnSetup();
	afx_msg void OnBnClickedBtnQuery();
	virtual BOOL DestroyWindow();	
};
