
//	WM_APP  0x8000
#define	SM_DATA_READY			WM_APP+1
#define	SM_ERROR_SYSTEM			WM_APP+2
#define	SM_ERROR_API			WM_APP+3

// WM_USER 0x0400
#define ERR_WRITE_FAIL			WM_USER+1
#define ERR_SETTING_FAIL		WM_USER+2
#define ERR_SCANNER_NOT_OPEN	WM_USER+3
#define ERR_INVALID_FILE		WM_USER+4

// Barcode Type
#define BC_CODE11				100
#define BC_CODE39				101
#define BC_CODE93				102
#define BC_CODE128				103
#define BC_CODABAR				104
#define	BC_EAN8					105
#define	BC_EAN13				106
#define	BC_INDUSTRIAL_25		107
#define	BC_INTERLEAVED_25		108
#define	BC_STANDARD_25			109
#define	BC_MSI_PLESSEY			110
#define	BC_UK_PLESSEY			111
#define	BC_TELEPEN				112
#define	BC_UPCA					113
#define	BC_UPCE					114
#define	BC_MATRIX_25			115
#define	BC_PDF417				116
#define	BC_CODE16K				117
#define	BC_CHINAPOST			118
#define	BC_RSS14				119
#define	BC_RSS_LIMITED			120
#define	BC_RSS_EXPANDED			121
#define	BC_PHARMACODE			122
#define	BC_MICOR_PDF			123
#define	BC_EANUCC 				124
#define BC_IATA_25              125
#define BC_TRIOPTIC             126
#define BC_RSS                  127

struct GeneralSetting
{
	UINT	m_uiLED;
	UINT	m_uiBeep;
	UINT	m_uiVibrator;
	UINT	m_uiScanResume;

	UINT	m_uiPosition;
	UINT	m_uiAimID;
	
	UINT	m_uiGlobalMin;
	UINT	m_uiGlobalLock;
	UINT	m_ui1Type;
	UINT	m_ui1Length;
	UINT	m_ui2Type;
	UINT	m_ui2Length;
	UINT	m_ui3Type;
	UINT	m_ui3Length;
	UINT	m_ui4Type;
	UINT	m_ui4Length;
	UINT	m_ui5Type;
	UINT	m_ui5Length;
	UINT	m_ui6Type;
	UINT	m_ui6Length;
	UINT	m_ui7Type;
	UINT	m_ui7Length;

	UINT	m_uiScanTout;
	UINT	m_uiIdleTout;
	
	unsigned char	m_strPreamble[10];
	unsigned char	m_strPostamble[10];
};

struct Code11_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
};

struct Code39_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiFullASCII;
	UINT		m_uiXmitStarStop;
	UINT		m_uiPharmacode;
	UINT		m_uiPharmacodeOnly;
};

struct Code93_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
};

struct Code128_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
	UINT		m_uiUCCEAN128;
	UINT		m_uiISBT128;
	UINT		m_uiISBT128XmitID;
	UINT		m_uiISBT128Concat;
	UINT		m_uiISBT128Form;
};

struct Codabar_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiXmitStarStop;
	UINT		m_uiDualField;
};

struct EAN8_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiConvertToEAN13;
};

struct EAN13_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiISBNConvert;
	UINT		m_uiISBNSuppReq;
	UINT		m_uiISMNConvert;
	UINT		m_uiISMNSuppReq;
};

struct Industrial25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
};

struct Interleaved25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
};

struct MSI_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
};

struct UK_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
};

struct Telepen_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
	UINT		m_uiFullASCII;
};

struct UPCA_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiConvertToEAN13;
	UINT		m_uiCoupon;
	UINT		m_uiCouponXmitID;
	UINT		m_uiXmitNumSys;
};

struct UPCE_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
	UINT		m_uiConvertToUPCA;
	UINT		m_uiXmitNumSys;
};

struct Matrix25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCodeID;
};

struct UEGeneral_Setting
{
	UINT		m_uiSuppReq;
	UINT		m_ui2DigSupp;
	UINT		m_ui5DigSupp;
	UINT		m_ui2DigRedu;
	UINT		m_ui5DigRedu;
	UINT		m_uiGTIN;
};

struct IATA25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
};

struct Trioptic_Setting
{
	UINT		m_uiRead;
	UINT		m_uiCodeID;
	UINT		m_uiConversion;
};

struct RSS_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitAppID;
	UINT		m_uiXmitChkDig;
	UINT		m_uiXmitSymID;
};

struct ScannerSetting
{
	DWORD								cbSize;
	struct GeneralSetting				generalsetting;
	struct Code11_Setting				Code11;
	struct Code39_Setting				Code39;
	struct Code93_Setting				Code93;
	struct Code128_Setting				Code128;
	struct Codabar_Setting				Codabar;
	struct EAN8_Setting					EAN8;
	struct EAN13_Setting				EAN13;
	struct Industrial25_Setting			Indust25;
	struct Interleaved25_Setting		Inter25;
	struct MSI_Setting					MSIPlessey;
	struct UK_Setting					UKPlessey;
	struct Telepen_Setting				Telepen;
	struct UPCA_Setting					UPCA;
	struct UPCE_Setting					UPCE;
	struct Matrix25_Setting				Matrix25;
	struct UEGeneral_Setting			UEGeneral;
	struct IATA25_Setting				IATA25;
	struct Trioptic_Setting				Trioptic;
	struct RSS_Setting					RSS;
};

//API_SCAN related function
BOOL API_Register(HWND hwnd);
BOOL API_Register2(HANDLE	hHandle, int *pMessage);
void API_Unregister();

BOOL API_Reset();
DWORD API_GetError();
DWORD API_GetSysError();
UINT API_GetBarData(LPBYTE buffer, UINT *uiLength, UINT *uiBarType);
UINT API_GetBarDataLength();
UINT API_GetBarType();
void API_ResetBarData();
void API_GoodRead();

BOOL API_SaveSettingsToScanner();
BOOL API_SaveSettingsToFile(LPCTSTR filename);
BOOL API_LoadSettingsFromFile(LPCTSTR filename);

BOOL S2K_IsLoad();
BOOL S2K_Load(BOOL bLoad, DWORD dwTimeOut);

DWORD SCAN_ResumeSystem(BOOL bOn);
BOOL SCAN_SendCommand(int nCommand1, int nCommand2, char *pValue);
BOOL SCAN_QueryStatus(int nCommand1, int nCommand2, char *pReturn);
DWORD SCAN_BatchSetting(ScannerSetting setting);
DWORD SCAN_BatchRead(ScannerSetting *ReadBuf);

//SCAN2KEY related function
BOOL PT_OpenScan2Key();
void PT_CloseScan2Key();
int PT_SetToDefault();

//SCANNER related function
int PT_EnableScanner();
void PT_DisableScanner();
BOOL PT_CheckBarcodeData();
BOOL PT_GetBarcodeData(UINT *uiBarType, char *pBuffer, UINT *uiMaxBufferLen);
BOOL PT_SetDefault();

//SCANKEY related function
int GetLibraryVersion();
DWORD EnableTriggerKey(BOOL bEnable);
DWORD GetTriggerKeyStatus();
DWORD TriggerStatus();
DWORD PressTriggerKey(BOOL bPress);
