// ARGOXAPI_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ARGOXAPI_VC.h"
#include "ARGOXAPI_VCDlg.h"
#include "Sysapiax.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CARGOXAPI_VCDlg dialog

CARGOXAPI_VCDlg::CARGOXAPI_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CARGOXAPI_VCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CARGOXAPI_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMD, m_ctlCmd);
}

BEGIN_MESSAGE_MAP(CARGOXAPI_VCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EXECUTE, &CARGOXAPI_VCDlg::OnBnClickedExecute)
END_MESSAGE_MAP()


// CARGOXAPI_VCDlg message handlers

BOOL CARGOXAPI_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_ctlCmd.AddString(L"Suspend");
	m_ctlCmd.AddString(L"Enable activesync autoconnect");
	m_ctlCmd.AddString(L"Disable activesync autoconnect");
	m_ctlCmd.AddString(L"Enable touch panel");
	m_ctlCmd.AddString(L"Disable touch panel");
	m_ctlCmd.AddString(L"Get touch panel status");
	m_ctlCmd.AddString(L"Register \ Key Notification");
	m_ctlCmd.AddString(L"Register Trigger Key Notification");
	m_ctlCmd.AddString(L"Show chinese IME");
	m_ctlCmd.AddString(L"Hide chinese IME");
	m_ctlCmd.AddString(L"Show desktop");
	m_ctlCmd.AddString(L"Hide desktop");
	m_ctlCmd.AddString(L"Show windows explore toolbar");
	m_ctlCmd.AddString(L"Hide windows explore toolbar");
	m_ctlCmd.AddString(L"Show taskbar");
	m_ctlCmd.AddString(L"Hide taskbar");
	m_ctlCmd.AddString(L"Unregister \ Key Notification");
	m_ctlCmd.AddString(L"Unregister Trigger Key Notification");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CARGOXAPI_VCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_ARGOXAPI_VC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_ARGOXAPI_VC_DIALOG));
}
#endif


void CARGOXAPI_VCDlg::OnBnClickedExecute()
{
	// TODO: Add your control notification handler code here
	switch(m_ctlCmd.GetCurSel())
	{
		case 0: //Suspend
			CallSuspend();
			break;
		case 1: //Enable activesync autoconnect
			ShowMessage( EnableAutoConnect( TRUE ) );
			break;
		case 2: //Disable activesync autoconnect
			ShowMessage( EnableAutoConnect( FALSE ) );
			break;
		case 3: //Enable touch panel
			ShowMessage( !EnableTouchPanel( TRUE ) );
			break;
		case 4: //Disable touch panel
			ShowMessage( !EnableTouchPanel( FALSE ) );
			break;
		case 5: //Get touch panel status
			BOOL bEnable;
			DWORD dwRet;
			dwRet = GetTouchPanelStatus(&bEnable);
			if(!dwRet)
			{
				if(bEnable)
					AfxMessageBox( L"Touch Panel On" );
				else
					AfxMessageBox( L"Touch Panel Off" );
			}
			else
			{
				WCHAR buf[128];
				wsprintf(buf, L"Get Touch Panel Status Fail, %d", dwRet); 
				AfxMessageBox(buf);
				//AfxMessageBox( L"Get Touch Panel Status Fail" );
			}
			break;
		case 6: //Register Alpha Key Notification
			if( RegisterAlphaKeyNotification( this->m_hWnd, ( WM_USER + 0x0001 ) ) )
				AfxMessageBox( L"Register Alpha Key Fail" );
			else 
				AfxMessageBox( L"Register Alpha Key Success" );
			break;
		case 7: //Register Trigger Key Notification
			if( RegisterTriggerKeyNotification( this->m_hWnd, ( WM_USER + 0x0002 ) ) )
				AfxMessageBox( L"Register Trigger Key Fail" );
			else 
				AfxMessageBox( L"Register Trigger Key Success" );
			break;
		case 8: //Show chinese IME
			ShowMessage( ShowChineseIME( TRUE ) );
			break;
		case 9: //Hide chinese IME
			ShowMessage( ShowChineseIME( FALSE ) );
			break;
		case 10: //Show desktop
			ShowMessage( ShowDesktop( TRUE ) );
			break;
		case 11: //Hide desktop
			ShowMessage( ShowDesktop( FALSE ) );
			break;
		case 12: //Show explore toolbar
			ShowMessage( ShowExploreToolbar( TRUE ) );
			break;
		case 13: //Hide explore toolbar
			ShowMessage( ShowExploreToolbar( FALSE ) );
			break;
		case 14: //Show taskbar
			ShowMessage( ShowTaskbar( TRUE ) );
			break;
		case 15: //Hide taskbar
			ShowMessage( ShowTaskbar( FALSE ) );
			break;
		case 16: //Unregister Alpha Key Notification
			ShowMessage( !UnregisterAlphaKeyNotification( this->m_hWnd ) );
			break;
		case 17: //Unregister Trigger Key Notification
			ShowMessage( !UnregisterTriggerKeyNotification( this->m_hWnd ) );
			break;
	}

}

void CARGOXAPI_VCDlg::ShowMessage(BOOL bMsg)
{
	CString strTemp;
	m_ctlCmd.GetText( m_ctlCmd.GetCurSel(), strTemp );
	if( bMsg )
		MessageBox( strTemp+L" success!", L"result", MB_OK );
	else
		MessageBox( strTemp+ L" fail", L"result", MB_OK );
}

LRESULT CARGOXAPI_VCDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{

	switch(message)
	{
		case WM_USER+0x0001:
			AfxMessageBox( L"You Press Alpha Key" );
			return 0;
		case WM_USER+0x0002:
			if(wParam == 1)
				AfxMessageBox( L"You Press Trigger Key" );
			else
				AfxMessageBox( L"You Release Trigger Key" );
			return 0;
	}

	return CDialog::WindowProc(message, wParam, lParam);
}