// ARGOXSYS_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ARGOXSYS_VC.h"
#include "ARGOXSYS_VCDlg.h"
#include "Sysapiax.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define WinCE420
// CARGOXSYS_VCDlg dialog

CARGOXSYS_VCDlg::CARGOXSYS_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CARGOXSYS_VCDlg::IDD, pParent)
	, m_strInput(_T(""))
	, m_strOutput(_T(""))
{
	dwValue1 = dwValue2 = 0;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CARGOXSYS_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CMD, m_ctlCmd);
	DDX_Text(pDX, IDC_INPUT, m_strInput);
	DDX_Text(pDX, IDC_OUTPUT, m_strOutput);
	DDX_Control(pDX, IDC_OUTPUT, m_ctlOutput);
}

BEGIN_MESSAGE_MAP(CARGOXSYS_VCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_EXECUTE, &CARGOXSYS_VCDlg::OnBnClickedExecute)
END_MESSAGE_MAP()


// CARGOXSYS_VCDlg message handlers

BOOL CARGOXSYS_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	MoveWindow(0, 0, 240, 320);
	CenterWindow(GetDesktopWindow());	// center to the hpc screen
	// TODO: Add extra initialization here
	m_ctlCmd.AddString( L"Get Volume" );
	m_ctlCmd.AddString( L"Volume Up" );
	m_ctlCmd.AddString( L"Volume Down" );
	m_ctlCmd.AddString( L"Battery Status" );
	m_ctlCmd.AddString( L"Turn On Screen Backlight" );
	m_ctlCmd.AddString( L"Turn Off Screen Backlight" );
	m_ctlCmd.AddString( L"Query Backlight Intensity" );
	m_ctlCmd.AddString( L"Get Backlight Status" );
	m_ctlCmd.AddString( L"LCD Power Off And On" );
	m_ctlCmd.AddString( L"Set Backlight Super" );
	m_ctlCmd.AddString( L"Set Backlight Normal" );
	m_ctlCmd.AddString( L"Set Backlight Fine" );
	m_ctlCmd.AddString( L"Set Backlight Micro" );
	m_ctlCmd.AddString( L"Set Backlight Off" );
	m_ctlCmd.AddString( L"Enable Power Button" );
	m_ctlCmd.AddString( L"Disable Power Button" );
	m_ctlCmd.AddString( L"GetAlphaMode" );
	m_ctlCmd.AddString( L"Send Visual Key" );
	m_ctlCmd.AddString( L"SetAlphaMode 0" );
	m_ctlCmd.AddString( L"SetAlphaMode 1" );
	m_ctlCmd.AddString( L"SetAlphaMode 2" );
	m_ctlCmd.AddString( L"GetKeypadLEDStatus" );
	m_ctlCmd.AddString( L"Good Read LED On" );
	m_ctlCmd.AddString( L"Good Read LED Off" );
	m_ctlCmd.AddString( L"KeypadLEDOn" );
	m_ctlCmd.AddString( L"KeypadLEDOff" );
#ifndef WinCE420
	m_ctlCmd.AddString( L"Set KeypadLED Super" );
	m_ctlCmd.AddString( L"Set KeypadLED Normal" );
	m_ctlCmd.AddString( L"Set KeypadLED Fine" );
	m_ctlCmd.AddString( L"Set KeypadLED Micro" );
	m_ctlCmd.AddString( L"Set KeypadLED Off" );
	m_ctlCmd.AddString( L"Query KeypadLED Intensity" );
#endif	

	m_strInput="1234567890ABCDEFGHIJ";
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CARGOXSYS_VCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_ARGOXSYS_VC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_ARGOXSYS_VC_DIALOG));
}
#endif


void CARGOXSYS_VCDlg::OnBnClickedExecute()
{
	CString strTemp;
	// TODO: Add your control notification handler code here
	switch( m_ctlCmd.GetCurSel() )
	{
		case 0: //Get Volumn
			Audio_GetVolume( &dwValue2 );
			strTemp.Format( L"0x%X", dwValue2 );
			AfxMessageBox( strTemp );
			break;		
		case 1: //Volumn Up
			Audio_GetVolume( &dwValue1 );
			if( dwValue1 < 0xffffffff )
				dwValue1 += 0x33333333;
			Audio_SetVolume( dwValue1 );
			break;
		case 2: //Volumn Down
			Audio_GetVolume( &dwValue1 );
			if( dwValue1 > 0x0 )
				dwValue1 -= 0x33333333;
			Audio_SetVolume( dwValue1 );
			break;
		case 3: //Battery Status
			switch( GetBatteryStatus() )
			{
				case 0:
					MessageBox( L"Battery High", L"ARGOXSYS_VC", MB_OK );
					break;
				case 1:
					MessageBox( L"Battery Low", L"ARGOXSYS_VC", MB_OK );
					break;
				case 2:
					MessageBox( L"Battery Critical", L"ARGOXSYS_VC", MB_OK );
					break;
				case 3:
					MessageBox( L"Battery Charging", L"ARGOXSYS_VC", MB_OK );
					break;
				case 4:
					MessageBox( L"No Battery", L"ARGOXSYS_VC", MB_OK );
					break;
				case 5:
					MessageBox( L"Battery Unknown", L"ARGOXSYS_VC", MB_OK );
					break;
			}
			break;
		case 4: //Turn on backlight
			ShowMessage(BacklightOn(TRUE));
			break;
		case 5: //Turn off backlight
			ShowMessage(BacklightOn(FALSE));
			break;
		case 6: //Query Backlight
			Display_QueryBacklightIntensity( &dwValue1, &dwValue2 );
			strTemp.Format( L"AC Backlight: %d\nBattery Backlight: %d", dwValue1, dwValue2 );
			AfxMessageBox( strTemp );
			break;
		case 7: //Get backlight status
			if( GetBacklightStatus() )
				MessageBox( strTemp+ L"Backlight On", L"ARGOXSYS_VC", MB_OK );
			else
				MessageBox( strTemp+ L"Backlight Off", L"ARGOXSYS_VC", MB_OK );
			break;
		case 8: //LCD power off and on
			PowerOnLCD( FALSE );
			Sleep( 3000 );
			PowerOnLCD( TRUE );
			break;
		case 9: //Set backlight super
			ShowMessage( SetBacklightPWM( 100, 100 ) );
			break;
		case 10: //Set backlight normal
			ShowMessage( SetBacklightPWM( 75, 75 ) );
			break;
		case 11: //Set backlight fine
			ShowMessage( SetBacklightPWM( 50, 50 ) );
			break;
		case 12: //Set backlight micro
			ShowMessage( SetBacklightPWM( 25, 25 ) );
			break;
		case 13: //Set backlight off
			ShowMessage( SetBacklightPWM( 0, 0 ) );
			break;
		case 14: //Enable power button
			ShowMessage(EnablePowerButton(TRUE));
			break;
		case 15: //Disable power button
			ShowMessage(EnablePowerButton(FALSE));
			break;
		case 16: //GetAlphaMode
			switch( GetKeypadAlphaMode() )
			{
				case 0:
					MessageBox( L"Numeric mode", L"ARGOXSYS_VC", MB_OK );
					break;
				case 1:
					MessageBox( L"Lowercase letter mode", L"ARGOXSYS_VC", MB_OK );
					break;
				case 2:
					MessageBox( L"Uppercase letter mode", L"ARGOXSYS_VC", MB_OK );
					break;
			}
			break;
		case 17: //Send visual key
			UpdateData( TRUE );
			m_strOutput = "";
			UpdateData( FALSE );
			m_ctlOutput.SetFocus();
			for( int i = 0; i < m_strInput.GetLength(); i++ ) 
				SendKbdVisualKey( (unsigned char)m_strInput.GetAt( i ) );
			break;
		case 18: //SetAlphaMode 0
			ShowMessage( SetKeypadAlphaMode( 0 ) );
			break;
		case 19: //SetAlphaMode 1
			ShowMessage( SetKeypadAlphaMode( 1 ) );
			break;
		case 20: //SetAlphaMode 2
			ShowMessage( SetKeypadAlphaMode( 2 ) );
			break;
		case 21: //GetKeypadLEDStatus
			m_ctlCmd.GetText(m_ctlCmd.GetCurSel(),strTemp);

			if(GetKeypadLEDStatus())
				MessageBox(strTemp+_T(" Enable!"),_T("ARGOXSYS_VC"),MB_OK);
			else
				MessageBox(strTemp+_T(" Disable!"),_T("ARGOXSYS_VC"),MB_OK);

			break;
		case 22: //Good read LED on
			ShowMessage(GoodReadLEDOn(TRUE));
			break;
		case 23: //Good read LED off
			ShowMessage(GoodReadLEDOn(FALSE));
			break;
		case 24: //KeypadLEDOn
			ShowMessage(KeypadLEDOn(TRUE));
			break;
		case 25: //KeypadLEDOff
			ShowMessage(KeypadLEDOn(FALSE));
			break;
#ifndef WinCE420
		case 26: //Set SetKeypadLED PWM super
			ShowMessage( SetKeypadPWM( 100, 100 ) );
			break;
		case 27: //Set SetKeypadLED PWM normal
			ShowMessage( SetKeypadPWM( 75, 75 ) );
			break;
		case 28: //Set SetKeypadLED PWM fine
			ShowMessage( SetKeypadPWM( 50, 50 ) );
			break;
		case 29: //Set SetKeypadLED PWM micro
			ShowMessage( SetKeypadPWM( 25, 25 ) );
			break;
		case 30: //Set SetKeypadLED PWM off
			ShowMessage( SetKeypadPWM( 0, 0 ) );
			break;
		case 31: //Query KeypadLED
			QueryKeypadLEDIntensity( &dwValue1, &dwValue2 );
			strTemp.Format( L"AC KeypadLED: %d\nBattery KeypadLED: %d", dwValue1, dwValue2 );
			AfxMessageBox( strTemp );
			break;
#endif
	}	
}

void CARGOXSYS_VCDlg::ShowMessage(DWORD	dwMsg)
{
	CString strTemp;
	m_ctlCmd.GetText( m_ctlCmd.GetCurSel(), strTemp );

	switch(dwMsg)
	{
		case 0:
			MessageBox( strTemp + L" success", L"ARGOXSYS_VC", MB_OK );
			break;
		case 1:
			MessageBox( strTemp + L" fail", L"ARGOXSYS_VC", MB_OK );
			break;
		case 3:
			MessageBox( strTemp + L" Parameter error", L"ARGOXSYS_VC", MB_OK );
			break;
	}
}

