// BT_Test.h : main header file for the PROJECT_NAME application
//

#pragma once

#ifndef __AFXWIN_H__
	#error "include 'stdafx.h' before including this file for PCH"
#endif

#ifdef STANDARDSHELL_UI_MODEL
#include "resource.h"
#endif

#include "SYSAPIAX.h"
#include "SysErr.h"

typedef DWORD (_stdcall *pfnBT_On)(void);
typedef void (_stdcall *pfnBT_Off)(void);

typedef DWORD (_stdcall *pfnSetDiscoverMode)(BOOL bEnable);
typedef BOOL (_stdcall *pfnGetDiscoverMode)(void);
typedef DWORD (_stdcall *pfnSetSPPService)(BOOL bEnable);
typedef BOOL (_stdcall *pfnGetSPPService)(void);
typedef DWORD (_stdcall *pfnSetFTPService)(BOOL bEnable);
typedef BOOL (_stdcall *pfnGetFTPService)(void);
typedef DWORD (_stdcall *pfnSetFTPWriteable)(BOOL bWriteable);
typedef BOOL (_stdcall *pfnGetFTPWriteable)(void);
typedef DWORD (_stdcall *pfnSetFTPShareFolder)(WCHAR *strShareFolder);
typedef DWORD (_stdcall *pfnGetFTPShareFolder)(WCHAR *strBuf, int *nFolderLen);

typedef DWORD (_stdcall *pfnInitSearchBTDevice)(HANDLE hLookup);
typedef DWORD (_stdcall *pfnFindNextBTDevice)(HANDLE hLookup, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);
typedef DWORD (_stdcall *pfnEndSearchBTDevice)(HANDLE hLookup);
typedef DWORD (_stdcall *pfnInitSearchFTPDevice)(void);
typedef DWORD (_stdcall *pfnFindFirstFTPDevice)(DWORD *dwPos, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);
typedef DWORD (_stdcall *pfnFindNextFTPDevice)(DWORD *dwPos, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);
//typedef DWORD (_stdcall *pfnGetDeviceAddress)(DWORD dwPos, ULONGLONG *btAddress);
//typedef DWORD (_stdcall *pfnGetDeviceName)(DWORD dwPos, LPTSTR DeviceName, int *nMax);

typedef DWORD (_stdcall *pfnPairDevice)(ULONGLONG btAddress, unsigned char PinCode[16]);
typedef DWORD (_stdcall *pfnUnPairDevice)(ULONGLONG btAddress);

typedef DWORD (_stdcall *pfnGetComInfo)(int *nComSum, LPCWSTR pComValue, int *nComValueLen);
typedef DWORD (_stdcall *pfnConnectDevice)(ULONGLONG btAddress, CONNECT_INFO *Info, BOOL nConnect);
typedef DWORD (_stdcall *pfnGetConnectStatus)(ULONGLONG btAddress, int nConnectType, LPCWSTR pCom, int *nStatus);
//typedef DWORD (_stdcall *pfnSetSPPClientChannel)(ULONGLONG btAddress, int nChannel);
typedef DWORD (_stdcall *pfnGetSPPClientChannel)(ULONGLONG btAddress, int *nChannel);
typedef DWORD (_stdcall *pfnFindFirstFTPFile)(WCHAR *path, FTP_FILE *File);
typedef DWORD (_stdcall *pfnFindNextFTPFile)(FTP_FILE *File);
typedef DWORD (_stdcall *pfnGetFTPFile)(LPCWSTR pTarget);
typedef DWORD (_stdcall *pfnPutFTPFile)(LPCWSTR pSourceFile, LPCWSTR pTargetPath);
typedef DWORD (_stdcall *pfnCreateFTPFolder)(LPCWSTR pTarget);
typedef DWORD (_stdcall *pfnDeleteFTPFolder)(LPCWSTR pTarget);
typedef DWORD (_stdcall *pfnDeleteFTPFile)(LPCWSTR pTarget);

struct DEVICE_INFO
{
	ULONGLONG	btAddress;
	CString		strName;
};

// CBT_TestApp:
// See BT_Test.cpp for the implementation of this class
//

class CBT_TestApp : public CWinApp
{
public:
	HINSTANCE m_hLibrary;

	pfnBT_On				m_BT_On;
	pfnBT_Off				m_BT_Off;

	pfnSetDiscoverMode		m_SetDiscoverMode;
	pfnGetDiscoverMode		m_GetDiscoverMode;
	pfnSetSPPService		m_SetSPPService;
	pfnGetSPPService		m_GetSPPService;
	pfnSetFTPService		m_SetFTPService;
	pfnGetFTPService		m_GetFTPService;
	pfnSetFTPWriteable		m_SetFTPWriteable;
	pfnGetFTPWriteable		m_GetFTPWriteable;
	pfnSetFTPShareFolder	m_SetFTPShareFolder;
	pfnGetFTPShareFolder	m_GetFTPShareFolder;

	pfnInitSearchBTDevice	m_InitSearchBTDevice;
	pfnFindNextBTDevice		m_FindNextBTDevice;
	pfnEndSearchBTDevice	m_EndSearchBTDevice;
	pfnInitSearchFTPDevice	m_InitSearchFTPDevice;
	pfnFindFirstFTPDevice	m_FindFirstFTPDevice;
	pfnFindNextFTPDevice	m_FindNextFTPDevice;
	//pfnGetDeviceAddress		m_GetDeviceAddress;
	//pfnGetDeviceName		m_GetDeviceName;

	pfnPairDevice			m_PairDevice;
	pfnUnPairDevice			m_UnPairDevice;

	pfnGetComInfo			m_GetComInfo;
	pfnConnectDevice		m_ConnectDevice;
	pfnGetConnectStatus		m_GetConnectStatus;
	//pfnSetSPPClientChannel	m_SetSPPClientChannel;
	pfnGetSPPClientChannel	m_GetSPPClientChannel;
	pfnFindFirstFTPFile		m_FindFirstFTPFile;
	pfnFindNextFTPFile		m_FindNextFTPFile;
	pfnGetFTPFile			m_GetFTPFile;
	pfnPutFTPFile			m_PutFTPFile;
	pfnCreateFTPFolder		m_CreateFTPFolder;
	pfnDeleteFTPFolder		m_DeleteFTPFolder;
	pfnDeleteFTPFile		m_DeleteFTPFile;

	CBT_TestApp();
	
// Overrides
public:
	virtual BOOL InitInstance();

// Implementation

	DECLARE_MESSAGE_MAP()
};

extern CBT_TestApp theApp;
