// SetupPage.cpp : implementation file
//

#include "stdafx.h"
#include "BT_Test.h"
#include "SetupPage.h"

extern CBT_TestApp theApp;

// CSetupPage dialog

IMPLEMENT_DYNAMIC(CSetupPage, CPropertyPage)

CSetupPage::CSetupPage()
	: CPropertyPage(CSetupPage::IDD)
	, m_bDiscoverable(FALSE)
	, m_bSPPService(FALSE)
	, m_bFTPService(FALSE)
	, m_bFTPWriteable(FALSE)
	, m_strSharePath(_T(""))
{
	m_bDiscoverable = theApp.m_GetDiscoverMode();
	m_bSPPService = theApp.m_GetSPPService();
	m_bFTPService = theApp.m_GetFTPService();
	m_bFTPWriteable = theApp.m_GetFTPWriteable();

	WCHAR	buf[256];
	int		nMax = 256;
	theApp.m_GetFTPShareFolder(buf, &nMax);
	m_strSharePath.Format(_T("%s"), buf);
}

CSetupPage::~CSetupPage()
{
}

void CSetupPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK1, m_bDiscoverable);
	DDX_Check(pDX, IDC_CHECK2, m_bSPPService);
	DDX_Check(pDX, IDC_CHECK3, m_bFTPService);
	DDX_Check(pDX, IDC_CHECK4, m_bFTPWriteable);
	DDX_Text(pDX, IDC_EDIT1, m_strSharePath);
}


BEGIN_MESSAGE_MAP(CSetupPage, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON1, &CSetupPage::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CSetupPage::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CSetupPage::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CSetupPage::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CSetupPage::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_CHECK3, &CSetupPage::OnBnClickedCheck3)
END_MESSAGE_MAP()


// CSetupPage message handlers

void CSetupPage::OnBnClickedButton1()
{
	DWORD	dwErr;
	CString strTemp;

	UpdateData();
	dwErr = theApp.m_SetDiscoverMode(m_bDiscoverable);
	if(dwErr)
		strTemp.Format(_T("Set Discover mode error!\r\n%d"), dwErr);
	else
		strTemp.Format(_T("Set Discover mode Succeed"));

	AfxMessageBox(strTemp);
}

void CSetupPage::OnBnClickedButton2()
{
	DWORD	dwErr;
	CString strTemp;

	UpdateData();
	dwErr = theApp.m_SetSPPService(m_bSPPService);
	if(dwErr)
		strTemp.Format(_T("Set SPP service error!\r\n%d"), dwErr);
	else
		strTemp.Format(_T("Set SPP service Succeed"));

	AfxMessageBox(strTemp);
}

void CSetupPage::OnBnClickedButton3()
{
	DWORD	dwErr;
	CString strTemp;

	UpdateData();
	dwErr = theApp.m_SetFTPService(m_bFTPService);
	if(dwErr)
		strTemp.Format(_T("Set FTP service error!\r\n%d"), dwErr);
	else
		strTemp.Format(_T("Set FTP service Succeed"));

	AfxMessageBox(strTemp);
}

void CSetupPage::OnBnClickedButton4()
{
	DWORD	dwErr;
	CString strTemp;

	UpdateData();
	dwErr = theApp.m_SetFTPWriteable(m_bFTPWriteable);
	if(dwErr)
		strTemp.Format(_T("Set FTP writeable error!\r\n%d"), dwErr);
	else
		strTemp.Format(_T("Set FTP writeable Succeed"));

	AfxMessageBox(strTemp);
}

void CSetupPage::OnBnClickedButton5()
{
	DWORD	dwErr;
	CString strTemp;

	UpdateData();
	dwErr = theApp.m_SetFTPShareFolder(m_strSharePath.LockBuffer());
	if(dwErr)
		strTemp.Format(_T("Set FTP share folder error!\r\n%d"), dwErr);
	else
		strTemp.Format(_T("Set FTP share folder Succeed"));
	AfxMessageBox(strTemp);
}

void CSetupPage::OnBnClickedCheck3()
{
	UpdateData();
	GetDlgItem(IDC_CHECK4)->EnableWindow(m_bFTPService);
	GetDlgItem(IDC_EDIT1)->EnableWindow(m_bFTPService);
	GetDlgItem(IDC_BUTTON4)->EnableWindow(m_bFTPService);
	GetDlgItem(IDC_BUTTON5)->EnableWindow(m_bFTPService);
}

BOOL CSetupPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	OnBnClickedCheck3();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
