// S2K_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "S2K_VC.h"
#include "S2K_VCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HINSTANCE hLibrary;

typedef BOOL (_stdcall *pfnPT_OpenScan2Key)();
typedef int (_stdcall *pfnPT_CloseScan2Key)();
typedef int (_stdcall *pfnGetLibraryVersion)();
typedef int (_stdcall *pfnPT_SetToDefault)();

pfnPT_OpenScan2Key	PT_OpenScan2Key	= NULL;
pfnPT_CloseScan2Key	PT_CloseScan2Key	= NULL;
pfnGetLibraryVersion	GetLibraryVersion		= NULL;
pfnPT_SetToDefault	PT_SetToDefault		= NULL;

// CS2K_VCDlg dialog

CS2K_VCDlg::CS2K_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CS2K_VCDlg::IDD, pParent)
{
	m_bTrigger = TRUE;
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	VERIFY(hLibrary = ::LoadLibrary(_T("SCANAPIAX.DLL")));
	VERIFY(PT_OpenScan2Key	 = (pfnPT_OpenScan2Key) ::GetProcAddress(hLibrary, _T("PT_OpenScan2Key")));
	VERIFY(PT_CloseScan2Key = (pfnPT_CloseScan2Key) ::GetProcAddress(hLibrary, _T("PT_CloseScan2Key")));
	VERIFY(GetLibraryVersion = (pfnGetLibraryVersion) ::GetProcAddress(hLibrary, _T("GetLibraryVersion")));
	VERIFY(PT_SetToDefault = (pfnPT_SetToDefault) ::GetProcAddress(hLibrary, _T("PT_SetToDefault")));
}

void CS2K_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BTN_DEFAULT, m_ctlBtnDefault);
}

BEGIN_MESSAGE_MAP(CS2K_VCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_DEFAULT, &CS2K_VCDlg::OnBnClickedBtnDefault)
END_MESSAGE_MAP()


// CS2K_VCDlg message handlers

BOOL CS2K_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	int nVersion;
	CString strTemp;
	nVersion = GetLibraryVersion();
	//strTemp.Format(_T("Version = %d"), nVersion);
	//AfxMessageBox(strTemp);
	strTemp.Format(_T("%d"), nVersion);
	GetDlgItem(IDC_EDIT_VERSION)->SetWindowText(strTemp);

	PT_OpenScan2Key();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CS2K_VCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_S2K_VC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_S2K_VC_DIALOG));
}
#endif


BOOL CS2K_VCDlg::DestroyWindow()
{
	PT_CloseScan2Key();

	FreeLibrary(hLibrary);
	hLibrary = NULL;

	PT_OpenScan2Key = NULL;
	PT_CloseScan2Key = NULL;
	GetLibraryVersion = NULL;
	PT_SetToDefault = NULL;

	return CDialog::DestroyWindow();
}

void CS2K_VCDlg::OnBnClickedBtnDefault()
{
	m_ctlBtnDefault.EnableWindow( FALSE );
	PT_SetToDefault();
	m_ctlBtnDefault.EnableWindow( TRUE );
}
