// API_VS2005Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "API_VS2005.h"
#include "API_VS2005Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAPI_VS2005Dlg dialog

CAPI_VS2005Dlg::CAPI_VS2005Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAPI_VS2005Dlg::IDD, pParent)
	, m_strBarType(_T(""))
	, m_strBarData(_T(""))
	, m_uiLength(0)
	, m_uiGetType(0)
	, m_uiCommand1(0)
	, m_uiCommand2(0)
	, m_strValue(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAPI_VS2005Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_BARTYPE, m_strBarType);
	DDX_Text(pDX, IDC_EDIT_BARDATA, m_strBarData);
	DDX_Text(pDX, IDC_EDIT_LENGTH, m_uiLength);
	DDX_Text(pDX, IDC_EDIT_GETTYPE, m_uiGetType);
	DDX_Text(pDX, IDC_EDIT5, m_uiCommand1);
	DDX_Text(pDX, IDC_EDIT6, m_uiCommand2);
	DDX_Text(pDX, IDC_EDIT7, m_strValue);
}

BEGIN_MESSAGE_MAP(CAPI_VS2005Dlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_LOADSCAN, &CAPI_VS2005Dlg::OnBnClickedBtnLoadscan)
	ON_BN_CLICKED(IDC_BTN_TRIGGER, &CAPI_VS2005Dlg::OnBnClickedBtnTrigger)
	ON_BN_CLICKED(IDC_BTN_DETECTTRIGGER, &CAPI_VS2005Dlg::OnBnClickedBtnDetecttrigger)
	ON_BN_CLICKED(IDC_BTN_PRESS_TRIGGER, &CAPI_VS2005Dlg::OnBnClickedBtnPressTrigger)
	ON_BN_CLICKED(IDC_BTN_SAVESETTING, &CAPI_VS2005Dlg::OnBnClickedBtnSavesetting)
	ON_BN_CLICKED(IDC_BTN_SAVETOFILE, &CAPI_VS2005Dlg::OnBnClickedBtnSavetofile)
	ON_BN_CLICKED(IDC_BTN_LOADFROMFILE, &CAPI_VS2005Dlg::OnBnClickedBtnLoadfromfile)
	ON_BN_CLICKED(IDC_BTN_RESET, &CAPI_VS2005Dlg::OnBnClickedBtnReset)
	ON_BN_CLICKED(IDC_BTN_SETUP, &CAPI_VS2005Dlg::OnBnClickedBtnSetup)
	ON_BN_CLICKED(IDC_BTN_Query, &CAPI_VS2005Dlg::OnBnClickedBtnQuery)
	ON_BN_CLICKED(IDC_BTN_Version, &CAPI_VS2005Dlg::OnBnClickedBtnVersion)
	ON_BN_CLICKED(IDC_BTN_BATCH, &CAPI_VS2005Dlg::OnBnClickedBtnBatch)
END_MESSAGE_MAP()


// CAPI_VS2005Dlg message handlers

BOOL CAPI_VS2005Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	VERIFY( m_hLibrary = ::LoadLibrary( L"SCANAPIAX.DLL" ) );
	VERIFY( m_API_Register = (pfnAPI_Register)::GetProcAddress( m_hLibrary, L"API_Register" ) );
	VERIFY( m_API_Unregister = (pfnAPI_Unregister)::GetProcAddress( m_hLibrary, L"API_Unregister" ) );
	VERIFY( m_API_GetBarData = (pfnAPI_GetBarData)::GetProcAddress( m_hLibrary, L"API_GetBarData" ) );
	VERIFY( m_API_GetBarDataLength = (pfnAPI_GetBarDataLength)::GetProcAddress( m_hLibrary, L"API_GetBarDataLength" ) );
	VERIFY( m_API_GetBarType = (pfnAPI_GetBarType)::GetProcAddress( m_hLibrary, L"API_GetBarType" ) );
	VERIFY( m_API_GetError = (pfnAPI_GetError)::GetProcAddress( m_hLibrary, L"API_GetError" ) );
	VERIFY( m_API_GetSysError = (pfnAPI_GetSysError)::GetProcAddress( m_hLibrary, L"API_GetSysError" ) );
	VERIFY( m_API_GoodRead = (pfnAPI_GoodRead)::GetProcAddress( m_hLibrary, L"API_GoodRead" ) );
	VERIFY( m_API_LoadSettingsFromFile = (pfnAPI_LoadSettingsFromFile)::GetProcAddress( m_hLibrary, L"API_LoadSettingsFromFile" ) );
	VERIFY( m_API_Reset = (pfnAPI_Reset)::GetProcAddress( m_hLibrary, L"API_Reset" ) );
	VERIFY( m_API_ResetBarData = (pfnAPI_ResetBarData)::GetProcAddress( m_hLibrary, L"API_ResetBarData" ) );
	VERIFY( m_API_SaveSettingsToFile = (pfnAPI_SaveSettingsToFile)::GetProcAddress( m_hLibrary, L"API_SaveSettingsToFile" ) );
	VERIFY( m_API_SaveSettingsToScanner = (pfnAPI_SaveSettingsToScanner)::GetProcAddress( m_hLibrary, L"API_SaveSettingsToScanner" ) );
	VERIFY( m_S2K_IsLoad = (pfnS2K_IsLoad)::GetProcAddress( m_hLibrary, L"S2K_IsLoad" ) );
	VERIFY( m_S2K_Load = (pfnS2K_Load)::GetProcAddress( m_hLibrary, L"S2K_Load" ) );
	VERIFY( m_SCAN_QueryStatus = (pfnSCAN_QueryStatus)::GetProcAddress( m_hLibrary, L"SCAN_QueryStatus" ) );
	VERIFY( m_SCAN_SendCommand = (pfnSCAN_SendCommand)::GetProcAddress( m_hLibrary, L"SCAN_SendCommand" ) );
	VERIFY( m_SCAN_BatchSetting = (pfnSCAN_BatchSetting)::GetProcAddress(m_hLibrary, L"SCAN_BatchSetting"));
	VERIFY( m_SCAN_BatchRead = (pfnSCAN_BatchRead)::GetProcAddress(m_hLibrary, L"SCAN_BatchRead"));

	VERIFY( m_EnableTriggerKey = (pfnEnableTriggerKey)::GetProcAddress( m_hLibrary, L"EnableTriggerKey" ) );
	VERIFY( m_GetLibraryVersion = (pfnGetLibraryVersion)::GetProcAddress( m_hLibrary, L"GetLibraryVersion" ) );
	VERIFY( m_GetTriggerKeyStatus = (pfnGetTriggerKeyStatus)::GetProcAddress( m_hLibrary, L"GetTriggerKeyStatus" ) );
	VERIFY( m_PressTriggerKey = (pfnPressTriggerKey)::GetProcAddress( m_hLibrary, L"PressTriggerKey" ) );
	VERIFY( m_TriggerKeyStatus = (pfnTriggerKeyStatus)::GetProcAddress( m_hLibrary, L"TriggerStatus" ) );

	if( !m_API_Register( this->m_hWnd ) )
	{	
		AfxMessageBox( L"API_Register FAIL" );
		OnOK();
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CAPI_VS2005Dlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_API_VS2005_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_API_VS2005_DIALOG));
	}
}
#endif

void CAPI_VS2005Dlg::OnBnClickedBtnLoadscan()
{
	CString strTemp;
	if( m_S2K_IsLoad() )
	{
		if( m_S2K_Load( FALSE, 1000 ) )
			strTemp = L"Load";
	}
	else
	{
		if( m_S2K_Load( TRUE, 1000 ) )
			strTemp = L"UnLoad";
	}
	
	GetDlgItem( IDC_BTN_LOADSCAN )->SetWindowText( strTemp );
}

void CAPI_VS2005Dlg::OnBnClickedBtnTrigger()
{
	CString strTemp;

	if( m_GetTriggerKeyStatus() )
	{
		m_EnableTriggerKey( FALSE );
		strTemp = L"Enable";
	}
	else
	{
		m_EnableTriggerKey( TRUE );
		strTemp = L"Disable";
	}
	
	GetDlgItem( IDC_BTN_TRIGGER )->SetWindowText( strTemp );
}

void CAPI_VS2005Dlg::OnBnClickedBtnDetecttrigger()
{
	if( m_TriggerKeyStatus() )
		AfxMessageBox( L"Trigger Key is pressed" );
	else
		AfxMessageBox( L"Trigger Key is released" );
}

void CAPI_VS2005Dlg::OnBnClickedBtnPressTrigger()
{
	m_PressTriggerKey( TRUE );
	Sleep( 1000 );
	m_PressTriggerKey( FALSE );
}

void CAPI_VS2005Dlg::OnBnClickedBtnSavesetting()
{
	if( m_API_SaveSettingsToScanner() )
		AfxMessageBox( L"Save to Scanner Succeed");
	else
		AfxMessageBox( L"Save to Scanner Fail" );
}

void CAPI_VS2005Dlg::OnBnClickedBtnSavetofile()
{
	CString strFile;
	CFileDialog dlg( FALSE, L"axs", NULL, OFN_CREATEPROMPT, L"Scanner Settings Files (*.axs) |*.axs || " );

	if( dlg.DoModal() != IDOK )
		return;

	strFile = dlg.GetPathName();

	if( m_API_SaveSettingsToFile( strFile ) )
		AfxMessageBox( L"Save to file Succeed" );
	else
		AfxMessageBox( L"Save to file Fail" );
}

void CAPI_VS2005Dlg::OnBnClickedBtnLoadfromfile()
{
	CString strFile;
	
	CFileDialog dlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST);

	if( dlg.DoModal() != IDOK )
		return;

	strFile = dlg.GetPathName();

	if( m_API_LoadSettingsFromFile( strFile ) )
		AfxMessageBox( L"Load form file Succeed" );
	else
		AfxMessageBox( L"Load from file Fail" );
}

void CAPI_VS2005Dlg::OnBnClickedBtnReset()
{
	if( m_API_Reset() )
		AfxMessageBox( L"Reset Succeed" );
	else
		AfxMessageBox( L"Reset Fail" );
}

void CAPI_VS2005Dlg::OnBnClickedBtnSetup()
{
	char *pValue;
	int nLen;

	UpdateData();
	nLen = m_strValue.GetLength();
	pValue = (char*)new char[ nLen ];
	memset( pValue, 0, nLen );

	for( int i = 0 ; i < nLen ; i++ )
		*( pValue + i ) = (char)m_strValue.GetAt( i );

	if( m_SCAN_SendCommand( m_uiCommand1, m_uiCommand2, pValue ) )
		AfxMessageBox( L"Setup complete" );
	else
		AfxMessageBox( L"Setup false" );
	delete [] pValue;
}

LRESULT CAPI_VS2005Dlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	char *pBuf;
	UINT uiSize, uiType;
	DWORD	dwError;
	CString strMess;

	uiSize = uiType = 0;

	if( message == SM_DATA_READY )
	{
		m_uiLength = m_API_GetBarDataLength();
		m_uiGetType = m_API_GetBarType();
		m_strBarData.Empty();
		if( m_uiLength == 0 )
			m_strBarData = L"No Data";
		else
		{
			uiSize = m_uiLength + 1;
			pBuf = (char*)new char[ uiSize ];
			memset( pBuf, 0, uiSize );
			m_API_GetBarData( (LPBYTE)pBuf, &uiSize, &uiType );
			m_strBarType.Format( L"%d", uiType );
			for( int i = 0; i < (int)strlen(pBuf); i++ )
				m_strBarData += *( pBuf + i );
			delete [] pBuf;
			m_API_GoodRead();
		}
		UpdateData( FALSE );
		return 0;

	}
	else if( message == SM_ERROR_SYSTEM )
	{
		dwError = m_API_GetSysError();
		strMess.Format( L"System Error Code: %d", dwError );
		AfxMessageBox( strMess );
		return 0;
	}
	else if( message == SM_ERROR_API )
	{
		dwError = m_API_GetError();
		strMess.Format( L"API Error Code: %d", dwError );
		AfxMessageBox( strMess );
		return 0;
	}

	return CDialog::WindowProc( message, wParam, lParam );
}

void CAPI_VS2005Dlg::OnOK()
{
	m_uiCommand1 = 0;
	m_uiCommand2 = 0;
	UpdateData( FALSE );

	CDialog::OnOK();
}

void CAPI_VS2005Dlg::OnBnClickedBtnQuery()
{

	char	 pReturn[100];
	UpdateData( TRUE );
	CString str;
	memset( pReturn, 0, sizeof(pReturn));
	if( m_SCAN_QueryStatus( m_uiCommand1, m_uiCommand2, pReturn ) )
	{
		m_strValue = L"";
		for( int i = 0; i < (int)strlen(pReturn); i++ )
		{
			m_strValue += pReturn[ i ];	
		}
		AfxMessageBox( L"Query complete" );
	}
	else
		AfxMessageBox( L"Query False" );
	
	UpdateData( FALSE );

}

void CAPI_VS2005Dlg::OnBnClickedBtnVersion()
{
	int nVersion;
	CString str;
	nVersion = m_GetLibraryVersion();
	str.Format( L"Version = %d", nVersion );
	AfxMessageBox( str );
}

BOOL CAPI_VS2005Dlg::DestroyWindow()
{
	m_API_Unregister();
	FreeLibrary( m_hLibrary );

	m_hLibrary = NULL;
	m_API_Register = NULL;
	m_API_Unregister = NULL;
	m_API_GetBarData = NULL;
	m_API_GetBarDataLength = NULL;
	m_API_GetBarType = NULL;
	m_API_GetError = NULL;
	m_API_GetSysError = NULL;
	m_API_GoodRead = NULL;
	m_API_LoadSettingsFromFile = NULL;
	m_API_Reset = NULL;
	m_API_ResetBarData = NULL;
	m_API_SaveSettingsToFile = NULL;
	m_API_SaveSettingsToScanner = NULL;
	m_S2K_IsLoad = NULL;
	m_S2K_Load = NULL;
	m_SCAN_QueryStatus = NULL;
	m_SCAN_SendCommand = NULL;
	m_SCAN_BatchSetting = NULL;
	m_SCAN_BatchRead = NULL;

	m_EnableTriggerKey = NULL;
	m_GetLibraryVersion = NULL;
	m_GetTriggerKeyStatus = NULL;
	m_PressTriggerKey = NULL;
	m_TriggerKeyStatus = NULL;

	return CDialog::DestroyWindow();
}

void CAPI_VS2005Dlg::OnBnClickedBtnBatch()
{
	ScannerSetting setting;
	CString		strTemp;

	setting.cbSize = sizeof(ScannerSetting);

	if(!m_SCAN_BatchRead(&setting)){
		setting.generalsetting.m_uiLED = 0;
		setting.generalsetting.m_uiVibrator = 1;
		strcpy((char *)&setting.generalsetting.m_strPreamble[0], "456");
		strcpy((char *)&setting.generalsetting.m_strPostamble[0], "789");
		setting.Code11.m_uiRead = 1;
		setting.Code39.m_uiRead = 1;
		setting.Code93.m_uiRead = 1;
		setting.Code128.m_uiRead = 1;
		setting.Codabar.m_uiRead = 1;
		setting.EAN8.m_uiRead = 1;
		setting.EAN13.m_uiRead = 1;
		setting.Indust25.m_uiRead = 1;
		setting.Inter25.m_uiRead = 1;
		setting.MSIPlessey.m_uiRead = 1;
		setting.UKPlessey.m_uiRead = 1;
		setting.Telepen.m_uiRead = 1;
		setting.UPCA.m_uiRead = 1;
		setting.UPCE.m_uiRead = 1;
		setting.Matrix25.m_uiRead = 1;
		setting.PDF417.m_uiRead = 1;
		setting.Code16K.m_uiRead = 1;
		setting.ChinaPost.m_uiRead = 1;
		setting.Rss14.m_uiRead = 1;
		setting.RssLimited.m_uiRead = 1;
		setting.RssExpanded.m_uiRead = 1;
		setting.Pharmacode.m_uiRead = 1;
		setting.MicroPDF.m_uiRead = 1;
		setting.EANUCC.m_uiRead = 1;
		setting.IATA25.m_uiRead = 1;
		setting.Trioptic.m_uiRead = 1;
		setting.PosiCode.m_uiRead = 1;
		setting.CodablockF.m_uiRead = 1;
		setting.Code49.m_uiRead = 1;
		setting.TLC39.m_uiRead = 1;
		setting.Planet.m_uiRead = 1;
		setting.Postnet.m_uiRead = 1;
		setting.AustralianPost.m_uiRead = 1;
		setting.BritishPost.m_uiRead = 1;
		setting.CanadianPost.m_uiRead = 1;
		setting.JapanesePost.m_uiRead = 1;
		setting.KIXPost.m_uiRead = 1;
		setting.KoreaPost.m_uiRead = 1;
		setting.USPS.m_uiRead = 1;
		setting.UPU.m_uiRead = 1;
		setting.Aztec.m_uiRead = 1;
		setting.DataMatrix.m_uiRead = 1;
		setting.MaxiCode.m_uiRead = 1;
		setting.QRCode.m_uiRead = 1;
		setting.ChineseSensible.m_uiRead = 1;

		if(!m_SCAN_BatchSetting(setting))
			AfxMessageBox(_T("Setup complete"));
		else
			AfxMessageBox(_T("Setup fail"));
	}
}
