// BT structure
struct FTP_FILE
{
	int		nFileType;		// 0 --> File, 1 --> Folder
	WCHAR	strPath[MAX_PATH];
	WCHAR	strFile[MAX_PATH];
	DWORD	dwFileSize;
};

struct CONNECT_INFO
{
	int		nChannel;
	int		nConnectType;		// 1 --> SPP, 2 --> FTP
	WCHAR	strCom[6];			// "COM?"
};

// Display
DWORD SetBacklightPWM(int nACPowerPercent, int nBatteryPercent);
DWORD Display_QueryBacklightIntensity(LPDWORD lpdwACBacklight, LPDWORD lpdwBatteryBacklight);
DWORD BacklightOn(BOOL bOn);
DWORD GetBacklightStatus();
DWORD PowerOnLCD(BOOL bOn);
DWORD EnableTouchPanel(BOOL bEnable);
DWORD GetTouchPanelStatus(LPBOOL lpbEnable);

// Keypad
DWORD SendKbdVisualKey(byte Key);
DWORD SetKeypadAlphaMode(int nMode);
DWORD GetKeypadAlphaMode();
DWORD EnablePowerButton(BOOL bOn);

//	LED
DWORD GoodReadLEDOn(BOOL bOn);
DWORD KeypadLEDOn(BOOL bOn);
BOOL GetKeypadLEDStatus();
DWORD SetKeypadPWM(int nACPowerPercent, int nBatteryPercent);
DWORD QueryKeypadLEDIntensity(LPDWORD lpdwACKeypadLED, LPDWORD lpdwBatteryKeypadLED);

//	Battery
int GetBatteryStatus();

// Audio
DWORD Audio_SetVolume(DWORD dwVolume);
DWORD Audio_GetVolume(LPDWORD lpdwVolume);

//	System
DWORD RegisterAlphaKeyNotification(HANDLE hWnd, UINT uMsg);
DWORD UnregisterAlphaKeyNotification(HANDLE hWnd);
BOOL EnableAutoConnect(BOOL bEnable);
void CallSuspend();
BOOL ShowTaskbar(BOOL bShow);
BOOL ShowDesktop(BOOL bShow);
BOOL ShowExploreToolbar(BOOL bShow);
BOOL ShowChineseIME(BOOL bShow);
DWORD RegisterTriggerKeyNotification(HANDLE hWnd, UINT uMsg);
DWORD UnregisterTriggerKeyNotification(HANDLE hWnd);

//WLAN
BOOL WL_Enable();
BOOL WL_Disable();

//Vibrator
DWORD VibratorOn(BOOL bOn);


//Bluetooth function
//using bluetooth.exe
BOOL BT_Enable();
BOOL BT_Disable();

// On/Off BT Module
DWORD BT_On();
void BT_Off();

// BT Device Setting function
DWORD SetDiscoverMode(BOOL bEnable);
BOOL GetDiscoverMode();
DWORD SetSPPService(BOOL bEnable);
BOOL GetSPPService();
DWORD SetFTPService(BOOL bEnable);
BOOL GetFTPService();
DWORD SetFTPWriteable(BOOL bWriteable);
BOOL GetFTPWriteable();
DWORD SetFTPShareFolder(WCHAR *strShareFolder);
DWORD GetFTPShareFolder(WCHAR *strShareFolder, int *nFolderLen);

// BT Device Search function
DWORD InitSearchBTDevice(HANDLE *hLookup);
DWORD FindNextBTDevice(HANDLE hLookup, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);
DWORD EndSearchBTDevice(HANDLE hLookup);
DWORD InitSearchFTPDevice();
DWORD FindFirstFTPDevice(DWORD *dwPos, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);
DWORD FindNextFTPDevice(DWORD *dwPos, LPTSTR szDeviceName, ULONGLONG *btAddress, int nNameLen);

// Pair function
DWORD PairDevice(ULONGLONG btAddress, unsigned char PinCode[16]);
DWORD UnPairDevice(ULONGLONG btAddress);

// Service function
DWORD GetComInfo(int *nComSum, LPCWSTR pComValue, int *nComValueLen);
DWORD ConnectDevice(ULONGLONG btAddress, CONNECT_INFO *Info, BOOL bConnect);
DWORD GetConnectStatus(ULONGLONG btAddress, int	nConnectType, LPCWSTR pCom, int *nStatus);
DWORD GetSPPClientChannel(ULONGLONG btAddress, int *nChannel);
DWORD FindFirstFTPFile(WCHAR *path, FTP_FILE *File);
DWORD FindNextFTPFile(FTP_FILE *File);
DWORD GetFTPFile(LPCWSTR pTargetFile);
DWORD PutFTPFile(LPCWSTR pSourceFile, LPCWSTR pTargetPath);
DWORD CreateFTPFolder(LPCWSTR pTarget);
DWORD DeleteFTPFolder(LPCWSTR pTarget);
DWORD DeleteFTPFile(LPCWSTR pTarget);

