// BT_Test.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "BT_Test.h"
#include "BT_TestDlg.h"
#include "Sheet.h"
#include "SetupPage.h"
#include "SPPPage.h"
#include "FTPPage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBT_TestApp

BEGIN_MESSAGE_MAP(CBT_TestApp, CWinApp)
END_MESSAGE_MAP()


// CBT_TestApp construction
CBT_TestApp::CBT_TestApp()
	: CWinApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CBT_TestApp object
CBT_TestApp theApp;

// CBT_TestApp initialization

BOOL CBT_TestApp::InitInstance()
{

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("Local AppWizard-Generated Applications"));

	/*CBT_TestDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}*/

	VERIFY(m_hLibrary = ::LoadLibrary(_T("SYSAPIAX.DLL")));
	VERIFY(m_BT_On = (pfnBT_On)::GetProcAddress(m_hLibrary, _T("BT_On")));
	VERIFY(m_BT_Off = (pfnBT_Off)::GetProcAddress(m_hLibrary, _T("BT_Off")));
	VERIFY(m_SetDiscoverMode = (pfnSetDiscoverMode)::GetProcAddress(m_hLibrary, _T("SetDiscoverMode")));
	VERIFY(m_GetDiscoverMode = (pfnGetDiscoverMode)::GetProcAddress(m_hLibrary, _T("GetDiscoverMode")));
	VERIFY(m_SetSPPService = (pfnSetSPPService)::GetProcAddress(m_hLibrary, _T("SetSPPService")));
	VERIFY(m_GetSPPService = (pfnGetSPPService)::GetProcAddress(m_hLibrary, _T("GetSPPService")));
	VERIFY(m_SetFTPService = (pfnSetFTPService)::GetProcAddress(m_hLibrary, _T("SetFTPService")));
	VERIFY(m_GetFTPService = (pfnGetFTPService)::GetProcAddress(m_hLibrary, _T("GetFTPService")));
	VERIFY(m_SetFTPWriteable = (pfnSetFTPWriteable)::GetProcAddress(m_hLibrary, _T("SetFTPWriteable")));
	VERIFY(m_GetFTPWriteable = (pfnGetFTPWriteable)::GetProcAddress(m_hLibrary, _T("GetFTPWriteable")));
	VERIFY(m_SetFTPShareFolder = (pfnSetFTPShareFolder)::GetProcAddress(m_hLibrary, _T("SetFTPShareFolder")));
	VERIFY(m_GetFTPShareFolder = (pfnGetFTPShareFolder)::GetProcAddress(m_hLibrary, _T("GetFTPShareFolder")));

	VERIFY(m_InitSearchBTDevice = (pfnInitSearchBTDevice)::GetProcAddress(m_hLibrary, _T("InitSearchBTDevice")));
	VERIFY(m_FindNextBTDevice = (pfnFindNextBTDevice)::GetProcAddress(m_hLibrary, _T("FindNextBTDevice")));
	VERIFY(m_EndSearchBTDevice = (pfnEndSearchBTDevice)::GetProcAddress(m_hLibrary, _T("EndSearchBTDevice")));
	VERIFY(m_InitSearchFTPDevice = (pfnInitSearchFTPDevice)::GetProcAddress(m_hLibrary, _T("InitSearchFTPDevice")));
	VERIFY(m_FindFirstFTPDevice = (pfnFindFirstFTPDevice)::GetProcAddress(m_hLibrary, _T("FindFirstFTPDevice")));
	VERIFY(m_FindNextFTPDevice = (pfnFindNextFTPDevice)::GetProcAddress(m_hLibrary, _T("FindNextFTPDevice")));
	//VERIFY(m_GetDeviceAddress = (pfnGetDeviceAddress)::GetProcAddress(m_hLibrary, _T("GetDeviceAddress")));
	//VERIFY(m_GetDeviceName = (pfnGetDeviceName)::GetProcAddress(m_hLibrary, _T("GetDeviceName")));

	VERIFY(m_PairDevice = (pfnPairDevice)::GetProcAddress(m_hLibrary, _T("PairDevice")));
	VERIFY(m_UnPairDevice = (pfnUnPairDevice)::GetProcAddress(m_hLibrary, _T("UnPairDevice")));

	VERIFY(m_GetComInfo = (pfnGetComInfo)::GetProcAddress(m_hLibrary, _T("GetComInfo")));
	VERIFY(m_ConnectDevice = (pfnConnectDevice)::GetProcAddress(m_hLibrary, _T("ConnectDevice")));
	VERIFY(m_GetConnectStatus = (pfnGetConnectStatus)::GetProcAddress(m_hLibrary, _T("GetConnectStatus")));
	//VERIFY(m_SetSPPClientChannel = (pfnSetSPPClientChannel)::GetProcAddress(m_hLibrary, _T("SetSPPClientChannel")));
	VERIFY(m_GetSPPClientChannel = (pfnGetSPPClientChannel)::GetProcAddress(m_hLibrary, _T("GetSPPClientChannel")));
	VERIFY(m_FindFirstFTPFile = (pfnFindFirstFTPFile)::GetProcAddress(m_hLibrary, _T("FindFirstFTPFile")));
	VERIFY(m_FindNextFTPFile = (pfnFindNextFTPFile)::GetProcAddress(m_hLibrary, _T("FindNextFTPFile")));
	VERIFY(m_GetFTPFile = (pfnGetFTPFile)::GetProcAddress(m_hLibrary, _T("GetFTPFile")));
	VERIFY(m_PutFTPFile = (pfnPutFTPFile)::GetProcAddress(m_hLibrary, _T("PutFTPFile")));
	VERIFY(m_CreateFTPFolder = (pfnCreateFTPFolder)::GetProcAddress(m_hLibrary, _T("CreateFTPFolder")));
	VERIFY(m_DeleteFTPFolder = (pfnDeleteFTPFolder)::GetProcAddress(m_hLibrary, _T("DeleteFTPFolder")));
	VERIFY(m_DeleteFTPFile = (pfnDeleteFTPFile)::GetProcAddress(m_hLibrary, _T("DeleteFTPFile")));

	m_BT_On();

	CSheet		sheet(_T("BT Test"));
	CSetupPage	page1;
	CSPPPage	page2;
	CFTPPage	page3;

	sheet.AddPage(&page1);
	sheet.AddPage(&page2);
	sheet.AddPage(&page3);
	sheet.DoModal();

	m_BT_Off();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
