// FTPPage.cpp : implementation file
//

#include "stdafx.h"
#include "BT_Test.h"
#include "FTPPage.h"
#include "CreateFolderDlg.h"

extern CBT_TestApp theApp;

ULONGLONG btAddressFTP;

#define NAP_MASK                ((ULONGLONG) 0xFFFF00000000)
#define SAP_MASK                ((ULONGLONG) 0x0000FFFFFFFF)
#define NAP_BIT_OFFSET          (8 * 4)
#define SAP_BIT_OFFSET          (0)
#define GET_NAP(_bt_addr)       ((USHORT) (((_bt_addr) & NAP_MASK) >> NAP_BIT_OFFSET))
#define GET_SAP(_bt_addr)       ((ULONG)  (((_bt_addr) & SAP_MASK) >> SAP_BIT_OFFSET))

// CFTPPage dialog

IMPLEMENT_DYNAMIC(CFTPPage, CPropertyPage)

CFTPPage::CFTPPage()
	: CPropertyPage(CFTPPage::IDD)
{

}

CFTPPage::~CFTPPage()
{
}

void CFTPPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_ListDevice);
	DDX_Control(pDX, IDC_LIST2, m_ListFile);
}


BEGIN_MESSAGE_MAP(CFTPPage, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON1, &CFTPPage::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CFTPPage::OnBnClickedButton2)
	ON_LBN_SELCHANGE(IDC_LIST2, &CFTPPage::OnLbnSelchangeList2)
	ON_BN_CLICKED(IDC_BUTTON3, &CFTPPage::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CFTPPage::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CFTPPage::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CFTPPage::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CFTPPage::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CFTPPage::OnBnClickedButton8)
	ON_LBN_DBLCLK(IDC_LIST2, &CFTPPage::OnLbnDblclkList2)
END_MESSAGE_MAP()


// CFTPPage message handlers

BOOL CFTPPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	
	//FTP_FILE abc;
	//CONNECT_INFO def;

	//WCHAR buf[128];
	//wsprintf(buf, L"sizeof(FTP_FILE) = %d, sizeof(CONNECT_INFO) = %d", sizeof(abc), sizeof(def));
	//AfxMessageBox(buf);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFTPPage::OnBnClickedButton1()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	DWORD	dwErr = 0;
	int	nStatus;
	CString		strTemp;
	DEVICE_INFO *pDevice = m_ListFTPDevice.GetAt(m_ListFTPDevice.FindIndex(nSel));
	btAddressFTP = pDevice->btAddress;

	CONNECT_INFO ConnectInfo;
	ConnectInfo.nConnectType = 2;
	//ConnectInfo.cChannel = nChannel;
	//wcscpy(ConnectInfo.strCom, L"");

	dwErr = theApp.m_GetConnectStatus(pDevice->btAddress, 2, L"", &nStatus);
	if(dwErr == E_FUNC_SUCCEED && nStatus == 0)
	{
		dwErr = theApp.m_ConnectDevice(pDevice->btAddress, &ConnectInfo, 1);
		if(dwErr == E_FUNC_SUCCEED)
		{
			DirFile(_T(""));
			GetDlgItem(IDC_LIST2)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON5)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(TRUE);
			AfxMessageBox(L"Connect success");
		}
		else
		{
			strTemp.Format(_T("Connect fail!\r\n%d"), dwErr);
			AfxMessageBox(strTemp);
		}
	}
	else
	{
		strTemp.Format(_T("Get connect status fail, FTP exist!\r\ndwErr = %d, nStatus = %d"), dwErr, nStatus);
		AfxMessageBox(strTemp);
	}
}

void CFTPPage::DirFile(CString strPath)
{
	if(strPath.IsEmpty())
		strPath = _T("\\");

	FTP_FILE *File;
	DWORD	dwErr;
	CString strTemp;

	File = new FTP_FILE;
	m_ListFileInfo.RemoveAll();
	m_ListFile.ResetContent();
	dwErr = theApp.m_FindFirstFTPFile(strPath.LockBuffer(), File);

	if(dwErr)
		delete File;
	else
		m_ListFileInfo.AddTail(File);

	do{
		if(File->nFileType){
			strTemp.Format(_T("%s"), File->strPath);
			strTemp = strTemp.Right(strTemp.GetLength() - strTemp.ReverseFind(L'\\') - 1);
		}
		else
			strTemp.Format(_T("%s"), File->strFile);
	
		m_ListFile.AddString(strTemp);
		File = new FTP_FILE;
		dwErr = theApp.m_FindNextFTPFile(File);
		if(dwErr)
			delete File;
		else
			m_ListFileInfo.AddTail(File);
	}while(!dwErr);
}

void CFTPPage::OnBnClickedButton2()
{
	DirFile(_T(""));
}

void CFTPPage::OnLbnSelchangeList2()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));
	GetDlgItem(IDC_BUTTON3)->EnableWindow(!pFile->nFileType);
}

void CFTPPage::OnBnClickedButton3()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	CString strTemp;
	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));

	if(pFile->strPath[wcslen(pFile->strPath) - 1] == L'\\')
		strTemp.Format(_T("%s%s"), pFile->strPath, pFile->strFile);
	else
		strTemp.Format(_T("%s\\%s"), pFile->strPath, pFile->strFile);

	if(!theApp.m_GetFTPFile(strTemp.LockBuffer()))
		AfxMessageBox(_T("GetFile Succeed!!"));
	else
		AfxMessageBox(_T("GetFile Fail!!"));
}

void CFTPPage::OnBnClickedButton4()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	CFileDialog	dlg(TRUE, NULL, NULL, 0, NULL, NULL, 0);

	if(dlg.DoModal() != IDOK)
		return;

	CString strTemp;
	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));

	if(pFile->nFileType){
		strTemp.Format(_T("%s"), pFile->strPath);
		strTemp = strTemp.Left(strTemp.ReverseFind(L'\\') -1);
	}
	else
		strTemp.Format(_T("%s"), pFile->strPath);

	if(!theApp.m_PutFTPFile(dlg.GetPathName(), strTemp.LockBuffer())){
		AfxMessageBox(_T("PutFile Succeed!!"));
		DirFile(strTemp);
	}
	else
		AfxMessageBox(_T("PutFile Fail!!"));
}

void CFTPPage::OnBnClickedButton5()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	CString strTemp;
	DWORD	dwErr;
	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));

	if(pFile->nFileType){
		strTemp.Format(_T("%s"), pFile->strPath);
		dwErr = theApp.m_DeleteFTPFolder(strTemp.LockBuffer());
		strTemp = strTemp.Left(strTemp.ReverseFind(L'\\') - 1);
	}
	else{
		if(pFile->strPath[wcslen(pFile->strPath) - 1] == L'\\')
			strTemp.Format(_T("%s%s"), pFile->strPath, pFile->strFile);
		else
			strTemp.Format(_T("%s\\%s"), pFile->strPath, pFile->strFile);
		dwErr = theApp.m_DeleteFTPFile(strTemp.LockBuffer());
		strTemp.Format(_T("%s"), pFile->strPath);
	}

	if(!dwErr){
		AfxMessageBox(_T("Delete Succeed!!"));
		DirFile(strTemp);
	}
	else
		AfxMessageBox(_T("Delete Fail!!"));
}

void CFTPPage::OnBnClickedButton6()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	CCreateFolderDlg	dlg;
	if(dlg.DoModal() != IDOK || dlg.m_strFolderName.IsEmpty())
		return;

	CString strTemp;
	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));
	
	if(pFile->nFileType){
		strTemp.Format(_T("%s"), pFile->strPath);
		strTemp = strTemp.Left(strTemp.ReverseFind(L'\\'));
		strTemp += dlg.m_strFolderName;
	}
	else{
		if(pFile->strPath[wcslen(pFile->strPath) - 1] == L'\\')
			strTemp.Format(_T("%s%s"), pFile->strPath, dlg.m_strFolderName);
		else
			strTemp.Format(_T("%s\\%s"), pFile->strPath, dlg.m_strFolderName);
	}

	if(!theApp.m_CreateFTPFolder(strTemp.LockBuffer())){
		AfxMessageBox(_T("Create FTP Test Folder Succeed!!"));
		strTemp = strTemp.Left(strTemp.ReverseFind(L'\\') - 1);
		DirFile(strTemp);
	}
	else
		AfxMessageBox(_T("Create FTP Test Folder Fail!!"));
}

void CFTPPage::OnLbnDblclkList2()
{
	int nSel = m_ListFile.GetCurSel();
	if(nSel == -1)
		return;

	FTP_FILE *pFile = m_ListFileInfo.GetAt(m_ListFileInfo.FindIndex(nSel));
	if(!pFile->nFileType)
		return;

	DirFile(pFile->strPath);
}

void CFTPPage::OnBnClickedButton7()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	DWORD	dwErr = 0;
	int	nStatus;
	CString		strTemp;
	DEVICE_INFO *pDevice = m_ListFTPDevice.GetAt(m_ListFTPDevice.FindIndex(nSel));

	CONNECT_INFO ConnectInfo;
	ConnectInfo.nConnectType = 2;
	//ConnectInfo.cChannel = nChannel;
	//wcscpy(ConnectInfo.strCom, L"");

	dwErr = theApp.m_GetConnectStatus(pDevice->btAddress, 2, L"", &nStatus);
	if(dwErr == E_FUNC_SUCCEED && nStatus == 1)
	{
		dwErr = theApp.m_ConnectDevice(pDevice->btAddress, &ConnectInfo, 0);
		if(dwErr == E_FUNC_SUCCEED)
		{
			m_ListFile.ResetContent();
			m_ListFileInfo.RemoveAll();
			GetDlgItem(IDC_LIST2)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON5)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON6)->EnableWindow(FALSE);
			AfxMessageBox(L"Disonnect success");
		}
		else
		{
			strTemp.Format(_T("Disconnect fail!\r\n%d"), dwErr);
			AfxMessageBox(strTemp);
		}
	}
	else
	{
		strTemp.Format(_T("Get connect status fail, FTP not exist!\r\ndwErr = %d, nStatus = %d"), dwErr, nStatus);
		AfxMessageBox(strTemp);
	}
}

void CFTPPage::OnBnClickedButton8()
{
	DWORD	dwPos, dwRe;
	WCHAR	szDeviceName[256], szAddress[256];
	DEVICE_INFO *pDevice;
	CString	strTemp;

	m_ListDevice.ResetContent();
	UpdateWindow();

	memset(szDeviceName, 0, sizeof(szDeviceName));
	memset(szAddress, 0, sizeof(szAddress));
	pDevice = new DEVICE_INFO;
	theApp.m_InitSearchFTPDevice();

	dwRe = theApp.m_FindFirstFTPDevice(&dwPos, szDeviceName, &pDevice->btAddress, 256);
	pDevice->strName.Format(_T("%s"), szDeviceName);
	wsprintf(szAddress, L"%04X%08X", GET_NAP(pDevice->btAddress), GET_SAP(pDevice->btAddress));
	strTemp.Format(_T("%s(%s)"), szDeviceName, szAddress);
	m_ListFTPDevice.AddTail(pDevice);
	m_ListDevice.AddString(strTemp);

	while(dwRe == E_FUNC_SUCCEED)
	{
		memset(szDeviceName, 0, sizeof(szDeviceName));
		memset(szAddress, 0, sizeof(szAddress));
		pDevice = new DEVICE_INFO;
		dwRe = theApp.m_FindNextFTPDevice(&dwPos, szDeviceName, &pDevice->btAddress, 256);
		if(dwRe != E_FUNC_SUCCEED)
			break;

	//WCHAR buf[128];
	//wsprintf(buf,L"%X",pDevice->btAddress);
	//AfxMessageBox(buf);

		pDevice->strName.Format(_T("%s"), szDeviceName);
		wsprintf(szAddress, L"%04X%08X", GET_NAP(pDevice->btAddress), GET_SAP(pDevice->btAddress));
		strTemp.Format(_T("%s(%s)"), szDeviceName, szAddress);
		m_ListFTPDevice.AddTail(pDevice);
		m_ListDevice.AddString(strTemp);
	}
}