// SPPPage.cpp : implementation file
//

#include "stdafx.h"
#include "BT_Test.h"
#include "SPPPage.h"
#include "PinCode.h"

extern CBT_TestApp theApp;

ULONGLONG btAddressSPP;
CString m_strSPP;

//#define NAP_MASK                ((ULONGLONG) 0xFFFF00000000)
//#define SAP_MASK                ((ULONGLONG) 0x0000FFFFFFFF)
//#define NAP_BIT_OFFSET          (8 * 4)
//#define SAP_BIT_OFFSET          (0)
#define GET_NAP(_bt_addr)       ( (USHORT) (((_bt_addr) & (ULONGLONG)0xFFFF00000000) >> (8*4)) )
#define GET_SAP(_bt_addr)       ( (ULONG)  (((_bt_addr) & (ULONGLONG)0x0000FFFFFFFF) >> (0)) )

// CSPPPage dialog

IMPLEMENT_DYNAMIC(CSPPPage, CPropertyPage)

CSPPPage::CSPPPage()
	: CPropertyPage(CSPPPage::IDD)
	, m_strCOM(_T(""))
{
	m_bPair = FALSE;
	m_hCom = NULL;
}

CSPPPage::~CSPPPage()
{
	if(m_hCom)
		CloseHandle(m_hCom);
}

void CSPPPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_DEVICE, m_ListDevice);
	DDX_Text(pDX, IDC_EDIT1, m_strCOM);
}


BEGIN_MESSAGE_MAP(CSPPPage, CPropertyPage)
	ON_BN_CLICKED(IDC_BUTTON1, &CSPPPage::OnBnClickedButton1)
	ON_LBN_SELCHANGE(IDC_LIST_DEVICE, &CSPPPage::OnLbnSelchangeListDevice)
	ON_BN_CLICKED(IDC_BUTTON2, &CSPPPage::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CSPPPage::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON4, &CSPPPage::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CSPPPage::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CSPPPage::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CSPPPage::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CSPPPage::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CSPPPage::OnBnClickedButton9)
END_MESSAGE_MAP()


// CSPPPage message handlers

BOOL CSPPPage::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSPPPage::OnBnClickedButton1()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	DWORD	dwErr = 0;
	unsigned char	pin[16];
	CString		strTemp;
	DEVICE_INFO *pDevice = m_ListBTDevice.GetAt(m_ListBTDevice.FindIndex(nSel));

	if(m_bPair)
		dwErr = theApp.m_UnPairDevice(pDevice->btAddress);
	else{
		CPinCode	dlg;
		
		if(dlg.DoModal() != IDOK)
			return;

		WideCharToMultiByte(CP_ACP, WC_COMPOSITECHECK, dlg.m_strPIN.LockBuffer(), wcslen(dlg.m_strPIN), (LPSTR)pin, 16, NULL,NULL);
		dwErr = theApp.m_PairDevice(pDevice->btAddress, pin);
	}

	if(!dwErr){
		if(m_bPair){
			GetDlgItem(IDC_BUTTON1)->SetWindowTextW(_T("Pair"));
			GetDlgItem(IDC_BUTTON2)->EnableWindow(TRUE);
			AfxMessageBox(_T("Unpair succeed!"));
		}
		else{
			GetDlgItem(IDC_BUTTON1)->SetWindowTextW(_T("Unpair"));
			GetDlgItem(IDC_BUTTON2)->EnableWindow(FALSE);
			AfxMessageBox(_T("Pair succeed!"));
		}
		m_bPair = 1 - m_bPair;
	}
	else{
		if(m_bPair)
			strTemp.Format(_T("Unpair fail!\r\n%d"), dwErr);
		else
			strTemp.Format(_T("Pair fail!\r\n%d"), dwErr);
		AfxMessageBox(strTemp);
	}
}

void CSPPPage::OnLbnSelchangeListDevice()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	DWORD	dwErr = 0;
	int	nStatus = 0;
	CString		strTemp;
	DEVICE_INFO *pDevice = m_ListBTDevice.GetAt(m_ListBTDevice.FindIndex(nSel));

	//dwErr = theApp.m_GetConnectStatus(pDevice->btAddress, 1,  &nStatus);
	//if(!dwErr){
	//	if(nStatus)
	//		strTemp.Format(_T("Disconnect"));
	//	else
	//		strTemp.Format(_T("Connect"));
	//	GetDlgItem(IDC_BUTTON2)->SetWindowText(strTemp);
	//}
	//else{
	//	strTemp.Format(_T("Get connect status fail!\r\n%d"), dwErr);
	//	AfxMessageBox(strTemp);
	//}
}

void CSPPPage::OnBnClickedButton2()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	UpdateData(TRUE);
	DWORD dwErr = 0;
	int	nStatus, nChannel = 0;
	CString	strTemp,strCom;
	int	nComSum = 0, nComValueLen = 10;
	WCHAR pComValue[10];

	DEVICE_INFO *pDevice = m_ListBTDevice.GetAt(m_ListBTDevice.FindIndex(nSel));
	btAddressSPP = pDevice->btAddress;

	dwErr = theApp.m_GetSPPClientChannel(pDevice->btAddress, &nChannel);
	if(dwErr != E_FUNC_SUCCEED)
	{
		AfxMessageBox(L"Get SPP Client Channel fail");
		return;
	}

	dwErr = theApp.m_GetComInfo(&nComSum, pComValue, &nComValueLen);
	if(dwErr != E_FUNC_SUCCEED)
	{
		AfxMessageBox(L"Get Com Info fail");
		return;
	}

	if(wcsstr(pComValue, m_strCOM) == 0)
	{
		AfxMessageBox(L"COM parameter error");
		return;
	}

	m_strSPP = m_strCOM;
	strCom = L"COM" + m_strCOM;
	CONNECT_INFO ConnectInfo;
	ConnectInfo.nConnectType = 1;
	ConnectInfo.nChannel = nChannel;
	wcscpy(ConnectInfo.strCom, strCom);
	dwErr = theApp.m_GetConnectStatus(pDevice->btAddress, 1, strCom, &nStatus);
	if(dwErr == E_FUNC_SUCCEED && nStatus == 0)
	{
		dwErr = theApp.m_ConnectDevice(pDevice->btAddress, &ConnectInfo, 1);
		if(dwErr == E_FUNC_SUCCEED)
		{
			//GetDlgItem(IDC_BUTTON1)->EnableWindow(FALSE);
			//GetDlgItem(IDC_BUTTON3)->EnableWindow(TRUE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(TRUE);
			strTemp.Format(_T("Connect succeed"));
			AfxMessageBox(strTemp);
			return;
		}
		else
		{
			strTemp.Format(_T("Connect fail!\r\n%d"), dwErr);
			AfxMessageBox(strTemp);
			return;
		}
	}
	else
	{
		strTemp.Format(_T("Get connect status fail!\r\ndwErr = %d, nStatus = %d"), dwErr, nStatus);
		AfxMessageBox(strTemp);
	}
}

void CSPPPage::OnBnClickedButton3()
{
	//DWORD	dwWritten;
	//WriteFile(m_hCom, _T("123456"), 6, &dwWritten, NULL);

	DWORD dwNumberOfBytesRead;
	char	temp_buf[100];
	memset(temp_buf,0x0,sizeof(temp_buf));
	sprintf(temp_buf,"1234567890\r");

	if(!WriteFile(m_hCom, temp_buf, strlen(temp_buf), &dwNumberOfBytesRead, NULL))
		AfxMessageBox(L"write file fail");
}

void CSPPPage::OnBnClickedButton4()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	int			nChannel;
	CString		strTemp;
	DEVICE_INFO *pDevice = m_ListBTDevice.GetAt(m_ListBTDevice.FindIndex(nSel));

	theApp.m_GetSPPClientChannel(pDevice->btAddress, &nChannel);
	strTemp.Format(_T("channel: %d"), nChannel);
	AfxMessageBox(strTemp);
}

void CSPPPage::OnBnClickedButton5()
{
	int nSel = m_ListDevice.GetCurSel();
	if(nSel == -1)
		return;

	UpdateData(TRUE);
	DWORD dwErr = 0;
	int	nStatus, nChannel = 0;
	CString	strTemp, strCom;
	DEVICE_INFO *pDevice = m_ListBTDevice.GetAt(m_ListBTDevice.FindIndex(nSel));

	//dwErr = theApp.m_GetSPPClientChannel(pDevice->btAddress, &nChannel);
	//if(dwErr != E_FUNC_SUCCEED)
	//{
	//	AfxMessageBox(L"Get SPP Client Channel fail");
	//	return;
	//}

	strCom = L"COM" + m_strCOM;
	CONNECT_INFO ConnectInfo;
	ConnectInfo.nConnectType = 1;
	//ConnectInfo.nChannel = nChannel;
	wcscpy(ConnectInfo.strCom, strCom/*L"COM7"*/);
	dwErr = theApp.m_GetConnectStatus(pDevice->btAddress, 1, strCom/*L"COM7"*/, &nStatus);
	if(dwErr == E_FUNC_SUCCEED && nStatus == 1)
	{
		dwErr = theApp.m_ConnectDevice(pDevice->btAddress, &ConnectInfo, 0);
		if(dwErr == E_FUNC_SUCCEED)
		{
			//GetDlgItem(IDC_BUTTON1)->EnableWindow(TRUE);
			//GetDlgItem(IDC_BUTTON3)->EnableWindow(FALSE);
			GetDlgItem(IDC_BUTTON4)->EnableWindow(FALSE);
			strTemp.Format(_T("Disconnect succeed"));
			AfxMessageBox(strTemp);
			return;
		}
		else
		{
			strTemp.Format(_T("Disconnect fail!\r\n%d"), dwErr);
			AfxMessageBox(strTemp);
			return;
		}
	}
	else
	{
		strTemp.Format(_T("Get connect status fail!\r\ndwErr = %d, nStatus = %d"), dwErr, nStatus);
		AfxMessageBox(strTemp);
	}
}

void CSPPPage::OnBnClickedButton6()
{
	CString strCom;
	UpdateData(TRUE);
	if(m_strCOM.GetLength() != 1)
	{
	    AfxMessageBox(L"COM Parameter Error");
		return;
	}

	char szTemp[10];
	memset(szTemp,0x0,10);
	sprintf(szTemp,"%S",m_strCOM);
	strCom.Format(L"COM%d:",atoi(szTemp));

	m_hCom = CreateFile(strCom, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	if(m_hCom == INVALID_HANDLE_VALUE){
		AfxMessageBox(_T("Comport not open!"));
		return;
	}

	DCB dcb;
	PurgeComm(m_hCom, PURGE_TXCLEAR | PURGE_RXCLEAR);
	GetCommState(m_hCom, &dcb);
		
	dcb.BaudRate = CBR_38400;     // set the baud rate
	dcb.ByteSize = 8;             // data size, xmit, and rcv
	dcb.Parity = NOPARITY;        // no parity bit
	dcb.StopBits = ONESTOPBIT;    // one stop bit
	dcb.fOutxCtsFlow = FALSE;

	if(!SetCommState(m_hCom, &dcb)){
		CloseHandle(m_hCom);
		return ;
	}


	//FlushFileBuffers(m_hCom);

	AfxMessageBox (L"Open COM sucess");
}

void CSPPPage::OnBnClickedButton7()
{
	if(m_hCom)
	{
		CloseHandle(m_hCom);
		m_hCom = NULL;
	}

	AfxMessageBox (L"Close COM sucess");
}

void CSPPPage::OnBnClickedButton8()
{
	DWORD dwNumberOfBytesRead;
	char	temp_buf[100];
	memset(temp_buf,0x0,sizeof(temp_buf));

	if(!ReadFile(m_hCom, temp_buf, 100, &dwNumberOfBytesRead, NULL))
		AfxMessageBox(L"Read file fail");

	CString strTemp;
	strTemp.Format(L"Read COM file: %S",temp_buf);
    //GetDlgItem(IDC_EDIT1)->SetWindowTextW(strTemp);
	AfxMessageBox(strTemp);
}

void CSPPPage::OnBnClickedButton9()
{
	DWORD	dwRe;
	DEVICE_INFO *pDevice;
	ULONGLONG btAddress;
	HANDLE hLookup=0;
	WCHAR szAddress[13], szDeviceName[100], szTemp[128];

	m_ListDevice.ResetContent();
	UpdateWindow();

	dwRe = theApp.m_InitSearchBTDevice(&hLookup);
	if(dwRe == E_FUNC_ERROR)
		AfxMessageBox(L"InitSearchBTDevice fail");

	while(dwRe == E_FUNC_SUCCEED)
	{
		memset(szAddress,0x0,sizeof(szAddress));
		memset(szDeviceName,0x0,sizeof(szDeviceName));
		dwRe = theApp.m_FindNextBTDevice(hLookup, szDeviceName, &btAddress, 256);
		if(dwRe != E_FUNC_SUCCEED)
			break;
		pDevice = new DEVICE_INFO;
		pDevice->strName.Format(_T("%s"), szDeviceName);
		pDevice->btAddress = btAddress;
		m_ListBTDevice.AddTail(pDevice);
		wsprintf(szAddress, L"%04X%08X", GET_NAP(btAddress), GET_SAP(btAddress));
		wsprintf(szTemp, L"%s (%s)", szDeviceName, szAddress);
		m_ListDevice.AddString(szTemp);	
	}

	dwRe = theApp.m_EndSearchBTDevice(hLookup);
	if(dwRe == E_FUNC_ERROR)
		AfxMessageBox(L"EndSearchBTDevice fail");
}