// Image_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Image_VC.h"
#include "Image_VCDlg.h"


int iFileFormat = 1;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CImage_VCDlg dialog
CImage_VCDlg::CImage_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CImage_VCDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CImage_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CImage_VCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_GET_PICTURE, &CImage_VCDlg::OnBnClickedGetPicture)
	ON_BN_CLICKED(IDC_SET_SIZE, &CImage_VCDlg::OnBnClickedSetSize)
	ON_BN_CLICKED(IDC_INVERT, &CImage_VCDlg::OnBnClickedInvert)
	ON_BN_CLICKED(IDC_ROTATION, &CImage_VCDlg::OnBnClickedRotation)
	ON_BN_CLICKED(IDC_SET_FORMAT, &CImage_VCDlg::OnBnClickedSetFormat)
	ON_BN_CLICKED(IDC_SET_BRIGHT, &CImage_VCDlg::OnBnClickedSetBright)
	ON_BN_CLICKED(IDC_SET_TIMEOUT, &CImage_VCDlg::OnBnClickedSetTimeout)
	ON_BN_CLICKED(IDC_DEFAULT, &CImage_VCDlg::OnBnClickedDefault)
	ON_BN_CLICKED(IDC_SET_TRANSMIT, &CImage_VCDlg::OnBnClickedSetTransmit)
END_MESSAGE_MAP()


// CImage_VCDlg message handlers

BOOL CImage_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	MoveWindow(0,0,240,320);

	m_hLibrary = NULL;
	IMG_Open = NULL;
	IMG_Close = NULL;
	IMG_SetPictureSize = NULL;
	IMG_GetPictureSize = NULL;
	IMG_SetPictureFormat = NULL;
	IMG_GetPictureFormat = NULL;
	IMG_CapturePicture = NULL;
	IMG_SetInvert = NULL;
	IMG_GetInvert = NULL;
	IMG_SetRotation = NULL;
	IMG_GetRotation = NULL;
	IMG_SetProperty = NULL;
	IMG_GetProperty = NULL;
	IMG_SetRevise = NULL;
	IMG_GetRevise = NULL;
	IMG_SetQualityJPEG = NULL;
	IMG_GetQualityJPEG = NULL;
	IMG_SetFilter = NULL;
	IMG_GetFilter = NULL;
	IMG_SetTransmit = NULL;
	IMG_GetTransmit = NULL;
	IMG_SetScanTimeout = NULL;
	IMG_GetScanTimeout = NULL;
	IMG_Default = NULL;

	VERIFY( m_hLibrary = ::LoadLibrary( L"SCANAPIAX.DLL" ) );
	if(m_hLibrary != NULL)
	{
		VERIFY( TriggerStatus = (pfnTriggerStatus)::GetProcAddress( m_hLibrary, L"TriggerStatus" ) );
		VERIFY( IMG_Open = (pfnIMG_Open)::GetProcAddress( m_hLibrary, L"IMG_Open" ) );
		VERIFY( IMG_Close = (pfnIMG_Close)::GetProcAddress( m_hLibrary, L"IMG_Close" ) );
		VERIFY( IMG_SetPictureSize = (pfnIMG_SetPictureSize)::GetProcAddress( m_hLibrary, L"IMG_SetPictureSize" ) );
		VERIFY( IMG_GetPictureSize = (pfnIMG_GetPictureSize)::GetProcAddress( m_hLibrary, L"IMG_GetPictureSize" ) );
		VERIFY( IMG_SetPictureFormat = (pfnIMG_SetPictureFormat)::GetProcAddress( m_hLibrary, L"IMG_SetPictureFormat" ) );
		VERIFY( IMG_GetPictureFormat = (pfnIMG_GetPictureFormat)::GetProcAddress( m_hLibrary, L"IMG_GetPictureFormat" ) );
		VERIFY( IMG_CapturePicture = (pfnIMG_CapturePicture)::GetProcAddress( m_hLibrary, L"IMG_CapturePicture" ) );
		VERIFY( IMG_SetInvert = (pfnIMG_SetInvert)::GetProcAddress( m_hLibrary, L"IMG_SetInvert" ) );
		VERIFY( IMG_GetInvert = (pfnIMG_GetInvert)::GetProcAddress( m_hLibrary, L"IMG_GetInvert" ) );
		VERIFY( IMG_SetRotation = (pfnIMG_SetRotation)::GetProcAddress( m_hLibrary, L"IMG_SetRotation" ) );
		VERIFY( IMG_GetRotation = (pfnIMG_GetRotation)::GetProcAddress( m_hLibrary, L"IMG_GetRotation" ) );
		VERIFY( IMG_SetProperty = (pfnIMG_SetProperty)::GetProcAddress( m_hLibrary, L"IMG_SetProperty" ) );
		VERIFY( IMG_GetProperty = (pfnIMG_GetProperty)::GetProcAddress( m_hLibrary, L"IMG_GetProperty" ) );
		VERIFY( IMG_SetRevise = (pfnIMG_SetRevise)::GetProcAddress( m_hLibrary, L"IMG_SetRevise" ) );
		VERIFY( IMG_GetRevise = (pfnIMG_GetRevise)::GetProcAddress( m_hLibrary, L"IMG_GetRevise" ) );
		VERIFY( IMG_SetQualityJPEG = (pfnIMG_SetQualityJPEG)::GetProcAddress( m_hLibrary, L"IMG_SetQualityJPEG" ) );
		VERIFY( IMG_GetQualityJPEG = (pfnIMG_GetQualityJPEG)::GetProcAddress( m_hLibrary, L"IMG_GetQualityJPEG" ) );
		VERIFY( IMG_SetFilter = (pfnIMG_SetFilter)::GetProcAddress( m_hLibrary, L"IMG_SetFilter" ) );
		VERIFY( IMG_GetFilter = (pfnIMG_GetFilter)::GetProcAddress( m_hLibrary, L"IMG_GetFilter" ) );
		VERIFY( IMG_SetTransmit = (pfnIMG_SetTransmit)::GetProcAddress( m_hLibrary, L"IMG_SetTransmit" ) );
		VERIFY( IMG_GetTransmit = (pfnIMG_GetTransmit)::GetProcAddress( m_hLibrary, L"IMG_GetTransmit" ) );
		VERIFY( IMG_SetScanTimeout = (pfnIMG_SetScanTimeout)::GetProcAddress( m_hLibrary, L"IMG_SetScanTimeout" ) );
		VERIFY( IMG_GetScanTimeout = (pfnIMG_GetScanTimeout)::GetProcAddress( m_hLibrary, L"IMG_GetScanTimeout" ) );
		VERIFY( IMG_Default = (pfnIMG_Default)::GetProcAddress( m_hLibrary, L"IMG_Default" ) );
	}
	
	if(IMG_Open)
		IMG_Open();

	WCHAR szTemp[256];
	BOOL bValue1;
	int nValue1, nValue2, nValue3;

	if( IMG_GetPictureSize(&bValue1, &nValue1, &nValue2, &nValue3) )
		AfxMessageBox(L"Get Picture Size Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue1);
		GetDlgItem(IDC_POS_X)->SetWindowTextW(szTemp);
		wsprintf(szTemp,L"%d",nValue2);
		GetDlgItem(IDC_POS_Y)->SetWindowTextW(szTemp);
	}

	if( IMG_GetRotation(&nValue1) )
		AfxMessageBox(L"Get Rotation Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue1);
		GetDlgItem(IDC_ROTATE)->SetWindowTextW(szTemp);
	}

	if( IMG_GetPictureFormat(&nValue1) )
		AfxMessageBox(L"Get Picture Format Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue1);
		GetDlgItem(IDC_FORMAT)->SetWindowTextW(szTemp);
	}

	if( IMG_GetProperty(&nValue1, &nValue2, &bValue1) )
		AfxMessageBox(L"Get Picture Property Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue2);
		GetDlgItem(IDC_BRIGHT)->SetWindowTextW(szTemp);
	}

	if( IMG_GetScanTimeout(&nValue1) )
		AfxMessageBox(L"Get Scan Timeout Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue1);
		GetDlgItem(IDC_TIMEOUT)->SetWindowTextW(szTemp);
	}

	if( IMG_GetTransmit(&nValue1,&bValue1) )
		AfxMessageBox(L"Get Scan Timeout Fail !");
	else
	{
		wsprintf(szTemp,L"%d",nValue1);
		GetDlgItem(IDC_PIXEL)->SetWindowTextW(szTemp);
		wsprintf(szTemp,L"%d",bValue1);
		GetDlgItem(IDC_HISTOGRAM)->SetWindowTextW(szTemp);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CImage_VCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_IMAGE_VC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_IMAGE_VC_DIALOG));
	}
}
#endif


BOOL CImage_VCDlg::DestroyWindow()
{
	// TODO: Add your specialized code here and/or call the base class
	if(IMG_Close)
		IMG_Close();

	FreeLibrary(m_hLibrary);
	m_hLibrary = NULL;
	TriggerStatus = NULL;
	IMG_Open = NULL;
	IMG_Close = NULL;
	IMG_SetPictureSize = NULL;
	IMG_GetPictureSize = NULL;
	IMG_SetPictureFormat = NULL;
	IMG_GetPictureFormat = NULL;
	IMG_CapturePicture = NULL;
	IMG_SetInvert = NULL;
	IMG_GetInvert = NULL;
	IMG_SetRotation = NULL;
	IMG_GetRotation = NULL;
	IMG_SetProperty = NULL;
	IMG_GetProperty = NULL;
	IMG_SetRevise = NULL;
	IMG_GetRevise = NULL;
	IMG_SetQualityJPEG = NULL;
	IMG_GetQualityJPEG = NULL;
	IMG_SetFilter = NULL;
	IMG_GetFilter = NULL;
	IMG_SetTransmit = NULL;
	IMG_GetTransmit = NULL;
	IMG_SetScanTimeout = NULL;
	IMG_GetScanTimeout = NULL;
	IMG_Default = NULL;

	return CDialog::DestroyWindow();
}

void CImage_VCDlg::GetFileName(TCHAR* pInPath, TCHAR* pOutFilePath)
{
	int iNumber=0;
	BOOL bFile=0;

	// search for the first file name that's not in use.
	do
	{
		if(iFileFormat == 0)
			wsprintf(pOutFilePath, L"%s\\Img_%d.tif", pInPath, iNumber);
		if(iFileFormat == 1)
			wsprintf(pOutFilePath, L"%s\\Img_%d.jpg", pInPath, iNumber);
		if(iFileFormat == 2)
			wsprintf(pOutFilePath, L"%s\\Img_%d.bmp", pInPath, iNumber);

		bFile = CheckFileName(pOutFilePath);
		iNumber++;
	}while(bFile);
}

BOOL CImage_VCDlg::CheckFileName(CString strFile)
{
	HANDLE hFind;
	WIN32_FIND_DATA FindFileData;

	hFind = FindFirstFile(strFile, &FindFileData);
	if (hFind == INVALID_HANDLE_VALUE) 
		return false;
	else 
	{
		FindClose(hFind);
		return true;
	}
}

void CImage_VCDlg::OnBnClickedGetPicture()
{
	int iLen=0;
	WCHAR szPathFile[256], szOutFile[256];

	memset(szPathFile, 0, sizeof(szPathFile));
	memset(szOutFile, 0, sizeof(szOutFile));

	GetFileName(L"\\My Documents", szPathFile);
	iLen = wcslen(szPathFile);
	wcsncpy(szOutFile, szPathFile, iLen-4);

	if( IMG_CapturePicture(szOutFile) )
	{
		DeleteFile(szPathFile);
		AfxMessageBox(L"Image Capture Fail !");
	}
	
	PlaySound( L"\\Windows\\correct.wav", NULL, SND_FILENAME | SND_NODEFAULT );
}

void CImage_VCDlg::OnBnClickedSetSize()
{
	int iPosX, iPosY;
	CString strBuf;
	GetDlgItem(IDC_POS_X)->GetWindowTextW(strBuf);
	iPosX = _wtoi(strBuf);
	GetDlgItem(IDC_POS_Y)->GetWindowTextW(strBuf);
	iPosY = _wtoi(strBuf);

	if( IMG_SetPictureSize(1, iPosX, iPosY, 0) )
		AfxMessageBox(L"Set Picture Size Fail !");
	else
		AfxMessageBox(L"Set Picture Size Success !");
}

void CImage_VCDlg::OnBnClickedInvert()
{
	CString strBuf;
	GetDlgItem(IDC_INVERT)->GetWindowTextW(strBuf);
	if(strBuf.Find(L"Un") == -1)
	{
		if( IMG_SetInvert(1,1) )
			AfxMessageBox(L"Invert Fail !");
		else
			AfxMessageBox(L"Invert Success !");
		GetDlgItem(IDC_INVERT)->SetWindowTextW(L"UnInvert");
	}
	else
	{
		if( IMG_SetInvert(0,0) )
			AfxMessageBox(L"Invert Fail !");
		else
			AfxMessageBox(L"Invert Success !");
		GetDlgItem(IDC_INVERT)->SetWindowTextW(L"Invert");
	}
}

void CImage_VCDlg::OnBnClickedRotation()
{
	int iRotate;
	CString strBuf;
	GetDlgItem(IDC_ROTATE)->GetWindowTextW(strBuf);
	iRotate = _wtoi(strBuf);

	if( IMG_SetRotation(iRotate) )
		AfxMessageBox(L"Set Rotation Fail !");
	else
		AfxMessageBox(L"Set Rotation Success !");
}

void CImage_VCDlg::OnBnClickedSetFormat()
{
	int iFormat;
	CString strBuf;
	GetDlgItem(IDC_FORMAT)->GetWindowTextW(strBuf);

	if( ! strBuf.IsEmpty() )
	{
		iFormat = _wtoi(strBuf);
		if(iFormat != 0 && iFormat != 1 && iFormat != 2)
		{
			AfxMessageBox(L"File Format Error !");
			return;
		}

		if( IMG_SetPictureFormat(iFormat) )
			AfxMessageBox(L"Set File Format Fail !");
		else
		{
			iFileFormat = iFormat;
			AfxMessageBox(L"Set File Format Success !");
		}
	}
}

void CImage_VCDlg::OnBnClickedSetBright()
{
	CString strBuf;
	GetDlgItem(IDC_BRIGHT)->GetWindowTextW(strBuf);

	if( IMG_SetProperty(0, _wtoi(strBuf), 0) )
		AfxMessageBox(L"Set Bright Fail !");
	else
		AfxMessageBox(L"Set Bright Success !");
}

void CImage_VCDlg::OnBnClickedSetTimeout()
{
	CString strBuf;
	GetDlgItem(IDC_TIMEOUT)->GetWindowTextW(strBuf);

	if( IMG_SetScanTimeout(_wtoi(strBuf)) )
		AfxMessageBox(L"Set Timeout Fail !");
	else
		AfxMessageBox(L"Set Timeout Success !");
}

void CImage_VCDlg::OnBnClickedDefault()
{
	if( ! IMG_Default() )
		AfxMessageBox(L"Set Default Fail !");
	else
	{
		iFileFormat = 1;
		AfxMessageBox(L"Set Default Success !");
	}
}

void CImage_VCDlg::OnBnClickedSetTransmit()
{
	int iPixelShip;
	BOOL bHistogram;
	CString strBuf;

	GetDlgItem(IDC_PIXEL)->GetWindowTextW(strBuf);
	iPixelShip = _wtoi(strBuf);
	GetDlgItem(IDC_HISTOGRAM)->GetWindowTextW(strBuf);
	bHistogram = _wtoi(strBuf);

	if( IMG_SetTransmit(iPixelShip,bHistogram) )
		AfxMessageBox(L"Set Transmit Fail !");
	else
		AfxMessageBox(L"Set Transmit Success !");
}
