// Scanner_VCDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Scanner_VC.h"
#include "Scanner_VCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

HINSTANCE hLibrary;

typedef int (_stdcall *pfnPT_EnableScanner)();
typedef int (_stdcall *pfnPT_DisableScanner)();
typedef int (_stdcall *pfnPT_CheckBarcodeData)();
typedef int (_stdcall *pfnPT_GetBarcodeData)(UINT *uiBarType, char *pBuffer, UINT *uiMaxBufferLen);
typedef int (_stdcall *pfnPT_SetDefault)();

pfnPT_EnableScanner				PT_EnableScanner			= NULL;
pfnPT_DisableScanner				PT_DisableScanner			= NULL;
pfnPT_CheckBarcodeData		PT_CheckBarcodeData	= NULL;
pfnPT_GetBarcodeData			PT_GetBarcodeData		= NULL;
pfnPT_SetDefault						PT_SetDefault					= NULL;

// CScanner_VCDlg dialog

CScanner_VCDlg::CScanner_VCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScanner_VCDlg::IDD, pParent)
	, m_strScanData(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	//VERIFY(hLibrary = ::LoadLibrary(_T("Scanner.DLL")));
	VERIFY(hLibrary = ::LoadLibrary(_T("SCANAPIAX.DLL")));
	VERIFY(PT_EnableScanner = (pfnPT_EnableScanner) ::GetProcAddress(hLibrary, _T("PT_EnableScanner")));
	VERIFY(PT_DisableScanner = (pfnPT_DisableScanner) ::GetProcAddress(hLibrary, _T("PT_DisableScanner")));
	VERIFY(PT_CheckBarcodeData = (pfnPT_CheckBarcodeData) ::GetProcAddress(hLibrary, _T("PT_CheckBarcodeData")));
	VERIFY(PT_GetBarcodeData = (pfnPT_GetBarcodeData) ::GetProcAddress(hLibrary, _T("PT_GetBarcodeData")));
	VERIFY(PT_SetDefault = (pfnPT_SetDefault) ::GetProcAddress(hLibrary, _T("PT_SetDefault")));
}

void CScanner_VCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_DATA, m_strScanData);
}

BEGIN_MESSAGE_MAP(CScanner_VCDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_INITSCANNER, &CScanner_VCDlg::OnBnClickedBtnInitscanner)
	ON_BN_CLICKED(IDC_BTN_GET, &CScanner_VCDlg::OnBnClickedBtnGet)
END_MESSAGE_MAP()


// CScanner_VCDlg message handlers

BOOL CScanner_VCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	PT_EnableScanner();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CScanner_VCDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	DRA::RelayoutDialog(
		AfxGetInstanceHandle(), 
		this->m_hWnd, 
		DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_SCANNER_VC_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_SCANNER_VC_DIALOG));
}
#endif


void CScanner_VCDlg::OnBnClickedBtnInitscanner()
{
	if(PT_SetDefault())
		AfxMessageBox(_T("Succeed"));
	else
		AfxMessageBox(_T("Fail"));
}

void CScanner_VCDlg::OnBnClickedBtnGet()
{
	UINT	uiBarType, uiMaxLen, i;
	char	pBarData[200];
	CString strTemp;

	uiMaxLen = 200;
	uiBarType = 0;
	m_strScanData = _T("");
	memset(pBarData, 0, 200);

	if(PT_CheckBarcodeData()){
		if(PT_GetBarcodeData(&uiBarType, pBarData, &uiMaxLen)){
			for(i = 0 ; i < strlen(pBarData) ; i++)
				m_strScanData += *(pBarData + i);
		}
		else
			m_strScanData = _T("Can't get scan data");
	}
	else
		m_strScanData = _T("No Scan Data");

	strTemp.Format(_T("%d"), uiBarType);
	GetDlgItem(IDC_EDIT_BARTYPE)->SetWindowTextW(strTemp);
	GetDlgItem(IDC_EDIT_DATA)->SetWindowTextW(m_strScanData);
}

BOOL CScanner_VCDlg::DestroyWindow()
{
	PT_DisableScanner();

	FreeLibrary(hLibrary);
	hLibrary						= NULL;
	PT_EnableScanner			= NULL;
	PT_DisableScanner			= NULL;
	PT_CheckBarcodeData	= NULL;
	PT_GetBarcodeData		= NULL;
	PT_SetDefault					= NULL;

	return CDialog::DestroyWindow();
}
