
//	WM_APP  0x8000
#define	SM_DATA_READY			WM_APP+1
#define	SM_ERROR_SYSTEM			WM_APP+2
#define	SM_ERROR_API			WM_APP+3

// WM_USER 0x0400
#define ERR_WRITE_FAIL			WM_USER+1
#define ERR_SETTING_FAIL		WM_USER+2
#define ERR_SCANNER_NOT_OPEN	WM_USER+3
#define ERR_INVALID_FILE		WM_USER+4
//#define ERR_TIMEOUT				WM_USER+5

// Barcode Type
#define BC_CODE11				100
#define BC_CODE39				101
#define BC_CODE93				102
#define BC_CODE128				103
#define BC_CODABAR				104
#define	BC_EAN8					105
#define	BC_EAN13				106
//#define	BC_INDUSTRIAL_25		107
#define	BC_INTERLEAVED_25		108
//#define	BC_STANDARD_25			109
#define	BC_MSI_PLESSEY			110
#define	BC_UK_PLESSEY			111
#define	BC_TELEPEN				112
#define	BC_UPCA					113
#define	BC_UPCE					114
#define	BC_MATRIX_25			115
#define	BC_PDF417				116
#define	BC_CODE16K				117
#define	BC_CHINAPOST			118
//#define	BC_RSS14				119
//#define	BC_RSS_LIMITED			120
//#define	BC_RSS_EXPANDED			121
#define	BC_PHARMACODE			122
#define	BC_MICOR_PDF			123
//#define	BC_EANUCC 				124
//#define BC_IATA_25              125
#define BC_TRIOPTIC             126
//#define BC_RSS                  127
#define BC_UCCEAN128			128
#define BC_POSI_CODE            130
#define BC_CODEBLOCK_F          131
#define BC_CODE49               132
#define BC_TLC39                133
#define BC_PLANET               134
#define BC_POSTNET              135
#define BC_AUSTRALIAN_POST      136
#define BC_BRITISH_POST         137
#define BC_CANADIAN_POST        138
#define BC_JAPANESE_POST        139
#define BC_KIX_POST             140
#define BC_KOREA_POST           141
#define BC_USPS                 142
#define BC_UPU                  143
#define BC_AZTEC                144
#define BC_DATA_MATRIX          145
#define BC_MAXI_CODE            146
#define BC_QR_CODE              147
#define BC_CHINESE_SENSIBLE     148
#define BC_OCR					149
#define BC_INDUSTRIAL25_IATA25	150
#define BC_RSS_EANUCC           151


struct GeneralSetting
{
	UINT	m_uiLED;
	UINT	m_uiBeep;
	UINT	m_uiVibrator;
	UINT	m_uiScanResume;

	UINT	m_uiPosition;
	UINT	m_uiTransmit;
	UINT	m_uiAimID;
	
	UINT	m_uiInverte;
	UINT	m_uiScanTout;
	UINT	m_uiIdleTout;
	UINT	m_uiOrientation;
	
	unsigned char	m_strPreamble[10];
	unsigned char	m_strPostamble[10];
};

struct Code11_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Code39_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiFullASCII;
	UINT		m_uiXmitStarStop;
	UINT		m_uiAppend;
	UINT		m_uiCodePage;
};

struct Code93_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiCodePage;
};

struct Code128_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiISBT128;
	UINT		m_uiCodePage;
};

struct Codabar_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiXmitStarStop;
	UINT		m_uiConcat;
};

struct EAN8_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_ui2DigSupp;
	UINT		m_ui5DigSupp;
	UINT		m_uiSuppReq;
	UINT		m_uiSuppSep;
};

struct EAN13_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiISBNConvert;
	UINT		m_ui2DigSupp;
	UINT		m_ui5DigSupp;
	UINT		m_uiSuppReq;
	UINT		m_uiSuppSep;
};

struct Industrial25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Interleaved25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct MSI_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct UK_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Telepen_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiFullASCII;
};

struct UPCA_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiCoupon;
	UINT		m_uiXmitNumSys;
	UINT		m_ui2DigSupp;
	UINT		m_ui5DigSupp;
	UINT		m_uiSuppReq;
	UINT		m_uiSuppSep;
};

struct UPCE_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
	UINT		m_uiUPCE1;
	UINT		m_uiConvertToUPCA;
	UINT		m_uiXmitNumSys;
	UINT		m_ui2DigSupp;
	UINT		m_ui5DigSupp;
	UINT		m_uiSuppReq;
	UINT		m_uiSuppSep;
};

struct Matrix25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct PDF417_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Code16K_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct ChinaPost_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct RSS14_Setting
{
	UINT		m_uiRead;
};

struct RSSLimited_Setting
{
	UINT		m_uiRead;
};

struct RSSExpanded_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Pharmacode_Setting
{
	UINT		m_uiRead;
};

struct MicroPDF_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct EANUCC_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
	UINT		m_uiUPCEANVer;
};

struct IATA25_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Trioptic_Setting
{
	UINT		m_uiRead;
};

struct PosiCode_Setting
{
	UINT		m_uiRead;
	UINT		m_uiLimit;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct CodablockF_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct Code49_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct TLC39_Setting
{
	UINT		m_uiRead;
};

struct Planet_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
};

struct Postnet_Setting
{
	UINT		m_uiRead;
	UINT		m_uiXmitChkDig;
};

struct AustralianPost_Setting
{
	UINT		m_uiRead;
};

struct BritishPost_Setting
{
	UINT		m_uiRead;
};

struct CanadianPost_Setting
{
	UINT		m_uiRead;
};

struct JapanesePost_Setting
{
	UINT		m_uiRead;
};

struct KIXPost_Setting
{
	UINT		m_uiRead;
};

struct KoreaPost_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct USPS_Setting
{
	UINT		m_uiRead;
};

struct UPU_Setting
{
	UINT		m_uiRead;
};

struct Aztec_Setting
{
	UINT		m_uiRead;
	UINT		m_uiRunes;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct DataMatrix_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct MaxiCode_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct QRCode_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct ChineseSensible_Setting
{
	UINT		m_uiRead;
	UINT		m_uiMaxLen;
	UINT		m_uiMinLen;
};

struct OCR_Setting
{
	UINT		m_uiRead;
	unsigned char	m_strTemplate[200];
	unsigned char	m_strUserDefine_g[50];
	unsigned char	m_strUserDefine_h[50];
	unsigned char	m_strCheckChar[50];
};

struct ScannerSetting
{
	DWORD								cbSize;
	struct GeneralSetting				generalsetting;
	struct Code11_Setting				Code11;
	struct Code39_Setting				Code39;
	struct Code93_Setting				Code93;
	struct Code128_Setting				Code128;
	struct Codabar_Setting				Codabar;
	struct EAN8_Setting					EAN8;
	struct EAN13_Setting				EAN13;
	struct Industrial25_Setting			Indust25;
	struct Interleaved25_Setting		Inter25;
	struct MSI_Setting					MSIPlessey;
	struct UK_Setting					UKPlessey;
	struct Telepen_Setting				Telepen;
	struct UPCA_Setting					UPCA;
	struct UPCE_Setting					UPCE;
	struct Matrix25_Setting				Matrix25;
	struct PDF417_Setting				PDF417;
	struct Code16K_Setting				Code16K;
	struct ChinaPost_Setting			ChinaPost;
	struct RSS14_Setting				Rss14;
	struct RSSLimited_Setting			RssLimited;
	struct RSSExpanded_Setting			RssExpanded;
	struct Pharmacode_Setting			Pharmacode;
	struct MicroPDF_Setting				MicroPDF;
	struct EANUCC_Setting				EANUCC;
	struct IATA25_Setting				IATA25;
	struct Trioptic_Setting				Trioptic;
	struct PosiCode_Setting				PosiCode;
	struct CodablockF_Setting			CodablockF;
	struct Code49_Setting				Code49;
	struct TLC39_Setting				TLC39;
	struct Planet_Setting				Planet;
	struct Postnet_Setting				Postnet;
	struct AustralianPost_Setting		AustralianPost;
	struct BritishPost_Setting			BritishPost;
	struct CanadianPost_Setting			CanadianPost;
	struct JapanesePost_Setting			JapanesePost;
	struct KIXPost_Setting				KIXPost;
	struct KoreaPost_Setting			KoreaPost;
	struct USPS_Setting					USPS;
	struct UPU_Setting					UPU;
	struct Aztec_Setting				Aztec;
	struct DataMatrix_Setting			DataMatrix;
	struct MaxiCode_Setting				MaxiCode;
	struct QRCode_Setting				QRCode;
	struct ChineseSensible_Setting		ChineseSensible;
	struct OCR_Setting					OCR;
};

//API_SCAN related function
BOOL API_Register(HWND hwnd);
BOOL API_Register2(HANDLE	hHandle, int *pMessage);
void API_Unregister();

BOOL API_Reset();
DWORD API_GetError();
DWORD API_GetSysError();
UINT API_GetBarData(LPBYTE buffer, UINT *uiLength, UINT *uiBarType);
UINT API_GetBarDataLength();
UINT API_GetBarType();
void API_ResetBarData();
void API_GoodRead();

BOOL API_SaveSettingsToScanner();
BOOL API_SaveSettingsToFile(LPCTSTR filename);
BOOL API_LoadSettingsFromFile(LPCTSTR filename);

BOOL S2K_IsLoad();
BOOL S2K_Load(BOOL bLoad, DWORD dwTimeOut);

DWORD SCAN_ResumeSystem(BOOL bOn);
BOOL SCAN_SendCommand(int nCommand1, int nCommand2, char *pValue);
BOOL SCAN_QueryStatus(int nCommand1, int nCommand2, char *pReturn);
DWORD SCAN_BatchSetting(ScannerSetting setting);
DWORD SCAN_BatchRead(ScannerSetting *ReadBuf);

//SCAN2KEY related function
BOOL PT_OpenScan2Key();
void PT_CloseScan2Key();
int PT_SetToDefault();

//SCANNER related function
int PT_EnableScanner();
void PT_DisableScanner();
BOOL PT_CheckBarcodeData();
BOOL PT_GetBarcodeData(UINT *uiBarType, char *pBuffer, UINT *uiMaxBufferLen);
BOOL PT_SetDefault();

//SCANKEY related function
int GetLibraryVersion();
DWORD EnableTriggerKey(BOOL bEnable);
DWORD GetTriggerKeyStatus();
DWORD TriggerStatus();
DWORD PressTriggerKey(BOOL bPress);


//IMAGE related function
// Open/Close Image function
BOOL IMG_Open();
void IMG_Close();

// Basic setting function
DWORD IMG_SetPictureSize(BOOL bVGA, int nWidth, int nHeight, int nMargin);
DWORD IMG_GetPictureSize(BOOL *bVGA, int *nWidth, int *nHeight, int *nMargin);
DWORD IMG_SetPictureFormat(int nFormat);
DWORD IMG_GetPictureFormat(int *nFormat);
DWORD IMG_CapturePicture(WCHAR *lpFilePath);

// Advanced setting function
DWORD IMG_SetInvert(BOOL bFlip, BOOL bMirror);
DWORD IMG_GetInvert(BOOL *bFlip, BOOL *bMirror);
DWORD IMG_SetRotation(int nRotate);
DWORD IMG_GetRotation(int *nRotate);
DWORD IMG_SetProperty(int nEdgeSharp, int nBright, BOOL bContrast);
DWORD IMG_GetProperty(int *nEdgeSharp, int *nBright, BOOL *bContrast);
DWORD IMG_SetRevise(BOOL bCompensate, BOOL bNoiseReduce);
DWORD IMG_GetRevise(BOOL *bCompensate, BOOL *bNoiseReduce);
DWORD IMG_SetQualityJPEG(int nQuality);
DWORD IMG_GetQualityJPEG(int *nQuality);
DWORD IMG_SetFilter(BOOL bDistance, int nDocImage);
DWORD IMG_GetFilter(BOOL *bDistance, int *nDocImage);
DWORD IMG_SetTransmit(int nPixelShip, BOOL bHistogram);
DWORD IMG_GetTransmit(int *nPixelShip, BOOL *bHistogram);

// Other function
DWORD IMG_SetScanTimeout(int nTimeout);
DWORD IMG_GetScanTimeout(int *nTimeout);
BOOL IMG_Default();
